
#include "stdafx.h"
#include "AsselVw.h"

#include "AstralFrame.h"
#include "IDEFrame.h"

extern CIDEFrame frameide;

static CAstralVw *getAstralVw(CWnd *here) {
	return &static_cast<CAstralFrame *>(static_cast<CAsselFrame *>(here->GetParentFrame())->GetParentFrame())->vw;
}

// CAsselVw

CAsselVw::CAsselVw()
{
}

CAsselVw::~CAsselVw()
{
}

BEGIN_MESSAGE_MAP(CAsselVw, CListView)
	ON_NOTIFY_REFLECT(LVN_DELETEITEM, OnLvnDeleteitem)
	ON_NOTIFY_REFLECT(NM_CLICK, OnNMClick)
	ON_NOTIFY_REFLECT(LVN_ITEMCHANGED, OnLvnItemchanged)
END_MESSAGE_MAP()

void CAsselVw::OnInitialUpdate()
{
	CListView::OnInitialUpdate();

#define LC GetListCtrl()

	while (LC.DeleteColumn(0));

	LC.DeleteAllItems();

	LC.SetExtendedStyle(LC.GetExtendedStyle() |LVS_EX_FULLROWSELECT);

	LC.SetBkColor(RGB(0, 0, 88));
	LC.SetTextColor(RGB(255, 255, 255));
	LC.SetTextBkColor(RGB(0, 0, 88));

	LC.InsertColumn(0, "Addr", LVCFMT_LEFT, 80);

	LC.SetFont(frameide.GetFont());
}

BOOL CAsselVw::PreCreateWindow(CREATESTRUCT& cs)
{
	if (!CListView::PreCreateWindow(cs)) return false;

	cs.dwExStyle &= ~WS_EX_CLIENTEDGE;
	cs.style |= 0
		| LVS_REPORT
		| LVS_NOSORTHEADER
		| LVS_SINGLESEL
		| LVS_SHOWSELALWAYS
		;
	return true;
}

void CAsselVw::Reset()
{
	LC.DeleteAllItems();
}

void CAsselVw::OnLvnDeleteitem(NMHDR *pNMHDR, LRESULT *pResult)
{
	LPNMLISTVIEW pNMLV = reinterpret_cast<LPNMLISTVIEW>(pNMHDR);
	Site *site = reinterpret_cast<Site *>(pNMLV->lParam);
	if (site != NULL) {
		delete site;
	}
	*pResult = 0;
}

static CString formatAddr(DWORD addr)
{
	addr &= 0xFFFFFF;
	CString text; text.Format(
		"%02X/%04X"
		, (UINT)(addr >> 16)
		, (UINT)(addr & 0xFFFF)
		);
	return text;
}

void CAsselVw::AddSite(DWORD addr)
{
	int r = LC.InsertItem(LC.GetItemCount(), formatAddr(addr));
	if (r < 0) return;
	Site *site = new Site();
	site->addr = addr;
	LC.SetItemData(r, reinterpret_cast<DWORD_PTR>(site));
}

void CAsselVw::OnNMClick(NMHDR *pNMHDR, LRESULT *pResult)
{
#if 0
	int i = LC.GetNextItem(-1, LVNI_SELECTED);
	if (i != -1) {
		Site *site = reinterpret_cast<Site *>(LC.GetItemData(i));
		if (site != NULL) {
			getAstralVw(this)->Select(site->addr);
		}
	}
#endif
	*pResult = 0;
}

void CAsselVw::OnLvnItemchanged(NMHDR *pNMHDR, LRESULT *pResult)
{
	LPNMLISTVIEW pNMLV = reinterpret_cast<LPNMLISTVIEW>(pNMHDR);
	int i = pNMLV->iItem;
	if (i != -1) {
		Site *site = reinterpret_cast<Site *>(pNMLV->lParam);
		if (site != NULL) {
			getAstralVw(this)->Select(site->addr);
		}
	}
	*pResult = 0;
}
