
#pragma once

#include "SizeVuff.h"

class CM_Image
{
public:
	// 
	SizeBuff bito;
	char bibuff[sizeof(BITMAPINFOHEADER) + 256 * sizeof(RGBQUAD)];

	UINT cx;
	UINT cy;
	UINT pitch;

	// 
	CM_Image()
	{
		cx = cy = pitch = 0;
	}
	// 
	BITMAPINFO &bi()
	{
		return (BITMAPINFO &)bibuff[0];
	}
	// 
	RGBQUAD *clro()
	{
		return &bi().bmiColors[0];
	}
	// 
	bool Alloc(UINT cx, UINT cy)
	{
		if (512 < cx || 512 < cy)
			return false;

		this->pitch = (cx + 3) & (~3);
		this->cx = cx;
		this->cy = cy;

		bi().bmiHeader.biSize = sizeof(BITMAPINFOHEADER);
		bi().bmiHeader.biWidth = cx;
		bi().bmiHeader.biHeight = cy;
		bi().bmiHeader.biPlanes = 1;
		bi().bmiHeader.biBitCount = 8;
		bi().bmiHeader.biCompression = BI_RGB;
		bi().bmiHeader.biSizeImage = 0;
		bi().bmiHeader.biXPelsPerMeter = 0;
		bi().bmiHeader.biYPelsPerMeter = 0;
		bi().bmiHeader.biClrUsed = 0;
		bi().bmiHeader.biClrImportant = 0;

		if (!bito.Alloc(pitch * cy))
			return false;
		return true;
	}
	// 
	void SetPixel(UINT x, UINT y, BYTE o)
	{
		if (cx < x || cy < y)
			return;
		bito.GetData()[x + pitch * (cy -y -1)] = o;
	}
};

typedef enum {
	CM_r_Str,
	CM_r_Image,
	CM_r_BR,
}	CM_r_TYPE;

class CM_Record
{
public:
	// 
	CM_r_TYPE cmr;

	CString text;
	CM_Image imgo;
};

class CM_Report
{
public:
	// 
	CArray<CM_Record, CM_Record> rs;

	// 
	CM_Report()
	{
		rs.SetSize(0, 5);
	}
	// 
	const CM_Report &operator =(const CM_Report &r)
	{
		rs.Copy(r.rs);
		return *this;
	}
};

class CCustReport
{
public:
	// 
	virtual ~CCustReport() { }

	// 
	CString strDescription;
	// 
	CM_Report report;
};
