
#include "stdafx.h"
#include "CustomFrame.h"
#include "resource.h"
#include ".\customframe.h"

// CCustomFrame

CCustomFrame::CCustomFrame()
{
}

CCustomFrame::~CCustomFrame()
{
}

BEGIN_MESSAGE_MAP(CCustomFrame, CFrameWnd)
	ON_WM_CREATE()
	ON_COMMAND(ID_FILE_EXIT, OnFileExit)
	ON_WM_CLOSE()

	ON_AUTO_UPDATE_CONTROL_BAR(AFX_IDW_TOOLBAR)
	ON_AUTO_UPDATE_CONTROL_BAR(AFX_IDW_DIALOGBAR)

	ON_COMMAND(ID_EDIT_SELECT_ALL, OnEditSelectAll)
	ON_MESSAGE(WM_SETMESSAGESTRING, OnSetMessageString)
	ON_MESSAGE(WM_POPMESSAGESTRING, OnPopMessageString)
END_MESSAGE_MAP()

static UINT indicators[] =
{
	ID_SEPARATOR,           // status line indicator
	ID_INDICATOR_CAPS,
	ID_INDICATOR_NUM,
	ID_INDICATOR_SCRL,
};

int CCustomFrame::OnCreate(LPCREATESTRUCT lpCreateStruct)
{
	if (CFrameWnd::OnCreate(lpCreateStruct) == -1)
		return -1;

	//	===================================
	if (false
		|| !wndToolBar.CreateEx(this, 0 |TBSTYLE_FLAT, 0 |WS_CHILD |WS_VISIBLE |CBRS_ALIGN_LEFT |CBRS_GRIPPER |CBRS_TOOLTIPS, CRect(0,0,0,0), AFX_IDW_TOOLBAR)
		|| !wndToolBar.LoadToolBar(IDR_CUST)
	) {
		return -1;
	}
	wndToolBar.SetHeight(12 + GetSystemMetrics(SM_CYSMICON));

//	//	===================================
//	if (false
//		|| !wndStatusBar.Create(this)
//		|| !wndStatusBar.SetIndicators(indicators, sizeof(indicators)/sizeof(UINT))
//	) {
//		return -1;
//	}

	//	===================================
	CMenu *pMenu = new CMenu();
	pMenu->LoadMenu(IDR_CUST);

	if (false
		|| !wndMenuBar.Create(0 |WS_CHILD |WS_VISIBLE |TBSTYLE_FLAT |TBSTYLE_LIST |CCS_NODIVIDER, CRect(0, 0, 1, 1), this, 0x0100)
		|| !wndMenuBar.LoadMenu(pMenu)
	) {
		return -1;
	}

	wndMenuBar.AutoSize();
	wndMenuBar.SetOwner(this);

	if (false
		|| !wndRebar.Create(this, 0, 0 |WS_CHILD |WS_VISIBLE |WS_CLIPSIBLINGS |WS_CLIPCHILDREN |CBRS_ALIGN_TOP)
		|| !wndRebar.AddBar(&wndMenuBar)
	) {
		return -1;
	}

	//	===================================
//	if (false
//		|| !wndFRDock.Create("FullReport", this, AFX_IDW_DIALOGBAR, 0 |WS_CHILD |WS_VISIBLE |CBRS_RIGHT |CBRS_SIZE_DYNAMIC)
//	) {
//		return -1;
//	}

	EnableDocking(CBRS_ALIGN_ANY);

	wndToolBar.EnableDocking(CBRS_ALIGN_ANY);
	DockControlBar(&wndToolBar, AFX_IDW_DOCKBAR_LEFT);

//	wndFRDock.EnableDocking(CBRS_ORIENT_VERT);
//	DockControlBar(&wndFRDock, AFX_IDW_DOCKBAR_RIGHT);

	return 0;
}

BOOL CCustomFrame::OnCreateClient(LPCREATESTRUCT lpcs, CCreateContext* pContext)
{
	if (!vw.Create(NULL, NULL, AFX_WS_DEFAULT_VIEW, CRect(0, 0, 0, 0), this, AFX_IDW_PANE_FIRST, pContext))
		return false;
	return true;
}

BOOL CCustomFrame::PreCreateWindow(CREATESTRUCT& cs)
{
	if (!CFrameWnd::PreCreateWindow(cs)) return false;

	cs.dwExStyle &= ~WS_EX_CLIENTEDGE;
	cs.hMenu = NULL;
	return true;
}

void CCustomFrame::OnFileExit()
{
	ShowWindow(SW_HIDE);
}

void CCustomFrame::OnClose()
{
	ShowWindow(SW_HIDE);
}

void CCustomFrame::OnEditSelectAll()
{
	CEdit *p = (CEdit *)DYNAMIC_DOWNCAST(CEdit, CWnd::GetFocus());
	if (p != NULL) {
		int n = p->GetWindowTextLength();
		p->SetSel(0, n);
	}
}

LRESULT CCustomFrame::OnPopMessageString(WPARAM wParam, LPARAM lParam)
{
	CFrameWnd *pMainWnd = GetTopLevelFrame();
	if (pMainWnd != NULL) {
		const MSG *m = GetCurrentMessage();
		return pMainWnd->SendMessage(m->message, m->wParam, m->lParam);
	}
	return CFrameWnd::OnPopMessageString(wParam, lParam);
}

LRESULT CCustomFrame::OnSetMessageString(WPARAM wParam, LPARAM lParam)
{
	CFrameWnd *pMainWnd = GetTopLevelFrame();
	if (pMainWnd != NULL) {
		const MSG *m = GetCurrentMessage();
		return pMainWnd->SendMessage(m->message, m->wParam, m->lParam);
	}
	return CFrameWnd::OnSetMessageString(wParam, lParam);
}
