
#include "stdafx.h"
#include "DebApp.h"
#include "fprintf.h"

using namespace OSP;

namespace {

CString GetAppDir()
{
	return OSP_GetDir(OSP_GetModuleFileName(NULL));
}

CString GetCnfFile()
{
	return OSP_JoinPath(GetAppDir(), "fprintf.ini");
}

CString RelativeJoinPath(CString strBase, CString strAdd)
{
	if (strAdd.Left(2).Compare(".\\") == 0)
		return OSP_JoinPath(strBase, strAdd);
	return strAdd;
}

};

// CDebApp

CDebApp::CDebApp()
{

}

CDebApp::~CDebApp()
{

}

BOOL CDebApp::InitInstance()
{
	m_pszProfileName = _tcsdup(GetCnfFile());

	LoadCnf();

	return TRUE;
}

int CDebApp::ExitInstance()
{
	return CWinApp::ExitInstance();
}

BEGIN_MESSAGE_MAP(CDebApp, CWinApp)
	ON_THREAD_MESSAGE(PM_OUR_DEBUG, OnOurDebug)
END_MESSAGE_MAP()

extern "C" BYTE GUIQuit;

BOOL CDebApp::ML()
{
	ASSERT_VALID(this);
	_AFX_THREAD_STATE* pState = AfxGetThreadState();

	// for tracking the idle time state
	BOOL bIdle = TRUE;
	LONG lIdleCount = 0;

	// acquire and dispatch messages until a WM_QUIT message is received.
	for (;;)
	{
		// phase1: check to see if we can do idle work
		while (bIdle &&
			!::PeekMessage(&(pState->m_msgCur), NULL, NULL, NULL, PM_NOREMOVE))
		{
			// call OnIdle while in bIdle state
			if (!OnIdle(lIdleCount++))
				bIdle = FALSE; // assume "no idle" state
		}

		// phase2: pump messages while available
		while (::PeekMessage(&(pState->m_msgCur), NULL, NULL, NULL, PM_NOREMOVE))
		{
			// pump message, but quit on WM_QUIT
			if (!PumpMessage())
				return ExitInstance();

			// reset "no idle" state after pumping "normal" message
			//if (IsIdleMessage(&m_msgCur))
			if (IsIdleMessage(&(pState->m_msgCur)))
			{
				bIdle = TRUE;
				lIdleCount = 0;
			}
		}

		break;
	}

	if (GUIQuit == 0) Sleep(1);

	return true;
}

CDebApp theApp;

extern "C" void ML()
{
	theApp.ML();
}

extern CString LoadStr(UINT nID) {
	CString text;
	text.LoadString(nID);
	return text;
}

#include "DebFrame.h"
#include "resource.h"
#include "CustomFrame.h"
#include "AstralFrame.h"
#include "IDEFrame.h"

extern CIDEFrame frameide;
extern RECT rcWindow; // winlink.cpp
extern "C" int X, Y; // winlink.cpp
extern "C" void drawscreenwin(); // winlink.cpp
extern "C" DWORD FullScreen=0; // winlink.cpp
extern "C" unsigned char cvidmode;
extern "C" void initwinvideo();

void CDebApp::OnOurDebug(WPARAM wp, LPARAM)
{
	if (IsWindow(frameide)) {
		frameide.ShowWindow(SW_SHOW);
		return;
	}
	CWnd *pZsnes = CWnd::GetActiveWindow();
	frameide.LoadFrame(IDR_IDE, 0 |WS_OVERLAPPEDWINDOW);
	frameide.InitialUpdateFrame(NULL, true);
	m_pMainWnd = &frameide;
	if (pZsnes != NULL) {
		CRect rc;
		pZsnes->GetWindowRect(&rc);
		CRect rcMax(0, 0, GetSystemMetrics(SM_CXFULLSCREEN), GetSystemMetrics(SM_CYFULLSCREEN));
		CRect rcTo(0, rc.bottom, rcMax.right, rcMax.bottom);
		frameide.MoveWindow(&rcTo);
	}
	return;

#if 0
//		if (FullScreen == 1) {
//	         cvidmode=0;
//	         initwinvideo();
//	         Sleep(1000);
//		}
//	
//		CWnd *p = CWnd::GetActiveWindow();
//	
//		if (IsWindow(frame)) {
//			frame.ShowWindow(SW_SHOW);
//			framec.ShowWindow(SW_SHOW);
//			frameg.ShowWindow(SW_SHOWNA);
//			frame.SetActiveWindow();
//			framec.SetActiveWindow();
//			if (p != NULL && wp != 0) {
//				p->SetActiveWindow();
//			}
//			return;
//		}
//	
//		frame.DestroyWindow();
//		frame.LoadFrame(IDR_DEB, 0 |WS_OVERLAPPEDWINDOW, NULL, NULL);
//		if (p != NULL) {
//			CRect rc;
//			p->GetWindowRect(&rc);
//			rc.OffsetRect(0, -rc.top);
//			CRect rcMe = rc;
//			bool rightHand = GetSystemMetrics(SM_SWAPBUTTON) ? true : false;
//			rcMe.OffsetRect(
//				rightHand
//					? -rcMe.Width()
//					: +rcMe.Width()
//				, 0
//				);
//			int cx = GetSystemMetrics(SM_CXFULLSCREEN);
//			if (false);
//			else if (rcMe.left < 0)
//				rcMe.OffsetRect(-rcMe.left, 0);
//			else if (rcMe.right > cx)
//				rcMe.right = cx;
//	
//			frame.MoveWindow(rcMe.left, rcMe.top, rcMe.Width(), rcMe.Height());
//	
//			rc = rcMe;
//			rc.OffsetRect(
//				rightHand
//					? +rc.Width()
//					: -rc.Width()
//				, 0
//				);
//			if (false);
//			else if (rc.left < 0)
//				rc.OffsetRect(-rc.left, 0);
//			else if (rc.right > cx)
//				rc.OffsetRect(cx - rc.right, 0);
//	
//			p->MoveWindow(X = rc.left, Y = rc.top, rc.Width(), rc.Height());
//			CopyRect(&rcWindow, &rc);
//		}
//		frame.InitialUpdateFrame(NULL, true);
//	//	frame.ShowWindow(SW_SHOW);
//	
//		framec.DestroyWindow();
//		framec.LoadFrame(IDR_CUST, 0 |WS_OVERLAPPEDWINDOW, NULL, NULL);
//		{
//			CRect rc;
//			frame.GetWindowRect(&rc);
//			CRect rcMe;
//			framec.GetWindowRect(&rcMe);
//	
//			int cx = GetSystemMetrics(SM_CXFULLSCREEN);
//			int cy = GetSystemMetrics(SM_CYFULLSCREEN);
//	
//			rcMe.OffsetRect(rc.left - rcMe.left, rc.bottom - rcMe.top);
//			rcMe.right = _cpp_min(rcMe.right, cx);
//			rcMe.bottom = _cpp_min(rcMe.bottom, cy);
//	
//			if (p != NULL) {
//				CRect rc;
//				p->GetWindowRect(&rc);
//				rcMe.left = rc.left;
//			}
//	
//			framec.MoveWindow(rcMe.left, rcMe.top, rcMe.Width(), rcMe.Height());
//		}
//		framec.InitialUpdateFrame(NULL, true);
//	
//		CRect rect0;
//		frame.GetWindowRect(&rect0);
//	
//		frameg.DestroyWindow();
//		frameg.LoadFrame(IDR_ASTRAL, 0 |WS_OVERLAPPEDWINDOW, NULL, NULL);
//		frameg.MoveWindow(rect0.left, rect0.top, rect0.Width(), rect0.Height());
//		frameg.InitialUpdateFrame(NULL, true);
//		frameg.ShowWindow(SW_MINIMIZE);
//	
//		if (wp == 0) {
//			frame.SetActiveWindow();
//		} else if (p != NULL) {
//			p->SetActiveWindow();
//		}
#endif
	drawscreenwin();
}

bool CDebApp::LoadCnf()
{
	CString strCnf = GetCnfFile();

	CString strLoadMax;
	int r = ProfStr::GetProfileIntFrom("common", "scriptoMax", 0, strCnf);
	if (r < 0)
		return false;
	scriptoVec.clear();
	CString strDir = GetAppDir();
	for (int i = 1; i <= r; i++) {
		CString strAppName; strAppName.Format(
			"scripto%u", i
			);
		Scripto scr;
		if (!ProfStr::LoadProfileStringFrom(strAppName, "engine", scr.strEngine, "", strCnf) || scr.strEngine.IsEmpty())
			continue;
		if (!ProfStr::LoadProfileStringFrom(strAppName, "script", scr.strFile, "", strCnf) || scr.strFile.IsEmpty())
			continue;
		scr.fDisabled = ProfStr::GetProfileIntFrom(strAppName, "disabled", 0, strCnf) ? 1 : 0;
		scr.strFile = RelativeJoinPath(strDir, scr.strFile);
		scriptoVec.push_back(scr);
	}

	return true;
}
