
#include "stdafx.h"
#include "DebFrame.h"
#include "resource.h"
#include ".\debframe.h"

// CDebFrame

CDebFrame::CDebFrame()
{

}

CDebFrame::~CDebFrame()
{

}

BEGIN_MESSAGE_MAP(CDebFrame, CFrameWnd)
	ON_WM_CLOSE()
	ON_COMMAND(ID_FILE_EXIT, OnFileExit)
	ON_WM_CREATE()

	ON_AUTO_UPDATE_CONTROL_BAR(AFX_IDW_REBAR)
	ON_WM_MENUCHAR()
	ON_MESSAGE(WM_SETMESSAGESTRING, OnSetMessageString)
	ON_MESSAGE(WM_POPMESSAGESTRING, OnPopMessageString)
END_MESSAGE_MAP()

BOOL CDebFrame::OnCreateClient(LPCREATESTRUCT lpcs, CCreateContext* pContext)
{
	if (!vw.Create(NULL, NULL, AFX_WS_DEFAULT_VIEW, CRect(0, 0, 0, 0), this, AFX_IDW_PANE_FIRST, pContext))
		return false;
	return true;
}

void CDebFrame::OnClose()
{
	ShowWindow(SW_HIDE);
}

BOOL CDebFrame::PreCreateWindow(CREATESTRUCT& cs)
{
	if (!CFrameWnd::PreCreateWindow(cs)) return false;

	cs.dwExStyle &= ~WS_EX_CLIENTEDGE;
	cs.hMenu = NULL;
	return true;
}

void CDebFrame::OnFileExit()
{
	ShowWindow(SW_HIDE);
}

static UINT indicators[] =
{
	ID_SEPARATOR,           // status line indicator
	ID_INDICATOR_CAPS,
	ID_INDICATOR_NUM,
	ID_INDICATOR_SCRL,
};

int CDebFrame::OnCreate(LPCREATESTRUCT lpCreateStruct)
{
	if (CFrameWnd::OnCreate(lpCreateStruct) == -1)
		return -1;

	//	===================================
	if (false
		|| !wndToolBar.CreateEx(this, 0 |TBSTYLE_FLAT, 0 |WS_CHILD |WS_VISIBLE |CBRS_SIZE_DYNAMIC |CBRS_ALIGN_LEFT |CBRS_GRIPPER |CBRS_TOOLTIPS)
		|| !wndToolBar.LoadToolBar(IDR_DEB)
	) {
		return -1;
	}
	wndToolBar.SetHeight(12 + GetSystemMetrics(SM_CYSMICON));

//	//	===================================
//	if (false
//		|| !wndStatusBar.Create(this)
//		|| !wndStatusBar.SetIndicators(indicators, sizeof(indicators)/sizeof(UINT))
//	) {
//		return -1;
//	}

	//	===================================
	CMenu *pMenu = new CMenu();
	pMenu->LoadMenu(IDR_DEB);

	if (false
		|| !wndMenuBar.Create(0 |WS_CHILD |WS_VISIBLE |TBSTYLE_FLAT |TBSTYLE_LIST |CCS_NODIVIDER, CRect(0, 0, 1, 1), this, 0x0100)
		|| !wndMenuBar.LoadMenu(pMenu)
	) {
		return -1;
	}

	wndMenuBar.AutoSize();
	wndMenuBar.SetOwner(this);

	if (false
		|| !wndRebar.Create(this, 0, 0 |WS_CHILD |WS_VISIBLE |WS_CLIPSIBLINGS |WS_CLIPCHILDREN |CBRS_ALIGN_TOP)
		|| !wndRebar.AddBar(&wndMenuBar)
	) {
		return -1;
	}

	//	===================================
	EnableDocking(CBRS_ALIGN_ANY);

	wndToolBar.EnableDocking(CBRS_ORIENT_ANY);
	DockControlBar(&wndToolBar, AFX_IDW_DOCKBAR_LEFT);

	return 0;
}

LRESULT CDebFrame::OnMenuChar(UINT nChar, UINT nFlags, CMenu* pMenu)
{
	if (wndMenuBar.OpenMenu(nChar)) return -1;

	return CFrameWnd::OnMenuChar(nChar, nFlags, pMenu);
}

LRESULT CDebFrame::OnPopMessageString(WPARAM wParam, LPARAM lParam)
{
	CFrameWnd *pMainWnd = GetTopLevelFrame();
	if (pMainWnd != NULL) {
		const MSG *m = GetCurrentMessage();
		return pMainWnd->SendMessage(m->message, m->wParam, m->lParam);
	}
	return CFrameWnd::OnPopMessageString(wParam, lParam);
}

LRESULT CDebFrame::OnSetMessageString(WPARAM wParam, LPARAM lParam)
{
	CFrameWnd *pMainWnd = GetTopLevelFrame();
	if (pMainWnd != NULL) {
		const MSG *m = GetCurrentMessage();
		return pMainWnd->SendMessage(m->message, m->wParam, m->lParam);
	}
	return CFrameWnd::OnSetMessageString(wParam, lParam);
}
