
#pragma once

class CDebVw : public CListView
{
	// 
	struct Label {
		DWORD no, branch;

		inline bool operator ==(const Label &r) const
		{
			return no == r.no && branch == r.branch;
		}
	};
	// 
	struct Ref {
		DWORD no, n;
	};
	// 
	struct Line {
		bool label;
		bool ref;
		DWORD occur;
		DWORD offset;
		DWORD exec, execo;
		BYTE status;

		Label labelx;
		Ref refx;

		Line(): label(false), ref(false), offset(0) { }
	};
	// 
	struct SubAddr {
		DWORD pos1, pos3;

		SubAddr() { }
		SubAddr(DWORD pos1, DWORD pos3): pos1(pos1), pos3(pos3) { }
	};
	// 
	typedef std::multimap<DWORD, Label> Addr2LabelMap;
	// 
	typedef std::map<DWORD, Ref> AddrRefMap;
	// 
	typedef std::multimap<DWORD, DWORD> AddrBranchMap;
	// 
	typedef std::multimap<DWORD, DWORD> Step2AddrMap;
	// 
	typedef std::set<DWORD> PassiveAddrSet, AddrSet;
	// 
	typedef std::multimap<DWORD, SubAddr> Step2SubAddrMap;
	// 
	typedef std::list<DWORD> AddrList;

	// 
	CString GetHintAt(UINT row, UINT col);
	// 
	inline CString GetHintProt0(UINT row, UINT col);
	inline CString GetHintProt1(UINT row, UINT col);
	inline CString GetHintProt2(UINT row, UINT col);

	// 
	CAtlArray<Line> lineVec;
	// 
	CString strDelay;
	// graph creation
	PassiveAddrSet pasvSet;
	// graph creation
	Step2SubAddrMap subssMap;
	// 
	char prot;

public:
	// 
	CFont m_fontLv;

	// 
	CDebVw();
	// 
	virtual ~CDebVw();
	// 
	void ResetContents();
	// 
	void NewProt(char protNew);
	// 
	inline void UseProt0();
	inline void UseProt1();
	inline void UseProt2();

	// 
	virtual void PostNcDestroy() { }

public:
#ifdef _DEBUG
	virtual void AssertValid() const;
	virtual void Dump(CDumpContext& dc) const;
#endif

protected:
	// 
	DECLARE_MESSAGE_MAP()
public:
	virtual void OnInitialUpdate();
protected:
	virtual BOOL PreCreateWindow(CREATESTRUCT& cs);
public:
	afx_msg int OnCreate(LPCREATESTRUCT lpCreateStruct);
	afx_msg void OnFileConvert();
	afx_msg void OnLvnGetdispinfo(NMHDR *pNMHDR, LRESULT *pResult);
	afx_msg void OnFileSaveCopyAs();
	afx_msg void OnLvnOdfinditem(NMHDR *pNMHDR, LRESULT *pResult);
	afx_msg void OnEditCopy();
	afx_msg void OnFileGraf();
	afx_msg void OnButtonSa1(UINT nID);
	afx_msg void OnUpdateButtonSa1(CCmdUI *pCmdUI);
};


