
#include "stdafx.h"
#include "FRDock.h"
#include ".\frdock.h"

// CFRDock

CFRDock::CFRDock()
{

}

CFRDock::~CFRDock()
{

}

BEGIN_MESSAGE_MAP(CFRDock, CSizingControlBarCF)
	ON_WM_CREATE()
	ON_WM_SIZE()
	ON_WM_CTLCOLOR()
	ON_WM_ERASEBKGND()
END_MESSAGE_MAP()

int CFRDock::OnCreate(LPCREATESTRUCT lpCreateStruct)
{
	const DWORD style = 0 
		|WS_VISIBLE 
		|WS_CHILD 
		|WS_HSCROLL
		|WS_VSCROLL
		|ES_AUTOHSCROLL 
		|ES_AUTOVSCROLL 
		|ES_MULTILINE 
		|ES_NOHIDESEL
		;

	if (CSizingControlBarCF::OnCreate(lpCreateStruct) == -1)
		return -1;
	if (!wndEdit.Create(style, CRect(0,0,0,0), this, AFX_IDW_PANE_FIRST))
		return -1;
	if (!vw.Create(NULL, NULL, AFX_WS_DEFAULT_VIEW, CRect(0,0,0,0), this, AFX_IDW_PANE_FIRST +1))
		return -1;

//	wndEdit.ModifyStyleEx(0, 0 |WS_EX_CLIENTEDGE);
	LOGFONT lf;
	ZeroMemory(&lf, sizeof(lf));
	if (GetObject(GetStockObject(DEFAULT_GUI_FONT), sizeof(lf), &lf) != sizeof(lf))
		return -1;
	lf.lfFaceName[0] = 0;
	lf.lfPitchAndFamily = 0 |FIXED_PITCH;
	if (!fontNew.CreateFontIndirect(&lf))
		return -1;
	wndEdit.SetFont(&fontNew);
	vw.SetFont(&fontNew);

	CClientDC dc(this);
	dc.SaveDC();
	dc.SelectObject(&fontNew);
	dc.GetTextMetrics(&tm);
	dc.RestoreDC(-1);

	nRows = 0;
	vw.tm = tm;

	return 0;
}

void CFRDock::OnSize(UINT nType, int cx, int cy)
{
	CSizingControlBarCF::OnSize(nType, cx, cy);

	CRect rc(0, 0, cx, cy);

	if (vw.report.rs.GetSize() == 0) {
		wndEdit.MoveWindow(&rc);
		vw.MoveWindow(0, 0, 0, 0);
	} else {
		int cy = tm.tmHeight * nRows + GetSystemMetrics(SM_CYHSCROLL);
		wndEdit.MoveWindow(0, 0, rc.Width(), cy);
		vw.MoveWindow(0, cy, rc.Width(), max(0, rc.Height() - cy));
	}
}

HBRUSH CFRDock::OnCtlColor(CDC* pDC, CWnd* pWnd, UINT nCtlColor)
{
	HBRUSH hbr = CSizingControlBarCF::OnCtlColor(pDC, pWnd, nCtlColor);

//	if (nCtlColor == CTLCOLOR_EDIT) {
		if (brback.m_hObject == NULL)
			brback.CreateSolidBrush(RGB(0, 0, 88));
		hbr = brback;
		pDC->SetBkColor(RGB(0, 0, 88));
		pDC->SetTextColor(RGB(255,255,255));
//	}

	return hbr;
}

void CFRDock::SetReport(CString strText, CM_Report &report)
{
	strText.Replace("\r\n", "\n");
	strText.Replace("\r", "\n");
	strText.Replace("\n", "\r\n");

	wndEdit.SetWindowText(strText);

	nRows = 1;
	LPCTSTR psz = strText;
	while (psz != NULL) {
		psz = _tcschr(psz, '\n');
		if (psz != NULL)
			psz++;
		nRows++;
	}

	CRect rc;
	GetClientRect(&rc);

	vw.report = report;

	if (vw.report.rs.GetSize() == 0) {
		wndEdit.MoveWindow(&rc);
		vw.MoveWindow(0, 0, 0, 0);
	} else {
		int cy = tm.tmHeight * nRows + GetSystemMetrics(SM_CYHSCROLL);
		wndEdit.MoveWindow(0, 0, rc.Width(), cy);
		vw.MoveWindow(0, cy, rc.Width(), max(0, rc.Height() - cy));
		vw.Invalidate();
	}
}

void CFRDock::Reset()
{
	CRect rc;
	GetClientRect(&rc);

	wndEdit.SetWindowText("");
	wndEdit.MoveWindow(&rc);

	vw.Reset();
	vw.MoveWindow(0, 0, 0, 0);
}

BOOL CFRDock::OnEraseBkgnd(CDC* pDC)
{
	return true;
}
