
#include "stdafx.h"
#include "resource.h"
#include "FRVw.h"
#include "IDEFrame.h"

extern CIDEFrame frameide;

// CFRVw

CFRVw::CFRVw()
{

}

CFRVw::~CFRVw()
{

}

BEGIN_MESSAGE_MAP(CFRVw, CScrollView)
	ON_WM_ERASEBKGND()
END_MESSAGE_MAP()

void CFRVw::OnInitialUpdate()
{
	CScrollView::OnInitialUpdate();

	Reset();
}

void CFRVw::OnDraw(CDC* pDC)
{
	CRect rc;
	GetClientRect(&rc);
	int x = 0, y = 0, cx = rc.Width(), cy = rc.Height(), rowcy = 0;

	pDC->SaveDC();
	pDC->SelectObject(frameide.fontFixedPitch);
	pDC->SetBkColor(RGB(0,0,88));
	pDC->SetTextColor(RGB(255,255,255));

	for (int i = 0; i < report.rs.GetSize(); i++) {
		CM_Record &rec = report.rs[i];

		CSize size;
		switch (rec.cmr) {
			case CM_r_Str:
				size = pDC->GetTextExtent(rec.text);
				break;
			case CM_r_Image:
				size.cx = rec.imgo.cx;
				size.cy = rec.imgo.cy;
				break;
			default:
				y += rowcy;
				x = 0;
				rowcy = 0;
				continue;
		}

		if (cx - x < size.cx) {
			y += rowcy;
			x = 0;
			rowcy = 0;
		}

		switch (rec.cmr) {
			case CM_r_Str:
				pDC->TextOut(x, y, rec.text);
				break;
			case CM_r_Image:
				SetDIBitsToDevice(
					*pDC,
					x,
					y,
					size.cx,
					size.cy,
					0,
					0,
					0,
					size.cy,
					rec.imgo.bito.GetData(),
					&rec.imgo.bi(),
					DIB_RGB_COLORS
					);
				break;
		}

		pDC->ExcludeClipRect(CRect(x, y, x +size.cx, y +size.cy));

		x += size.cx;
		rowcy = max(rowcy, size.cy);
	}

	pDC->FillSolidRect(rc, RGB(0,0,88));
	pDC->RestoreDC(-1);
}

void CFRVw::Reset()
{
	CSize sizeTotal;
	sizeTotal.cx = sizeTotal.cy = 0;
	SetScrollSizes(MM_TEXT, sizeTotal);
}

BOOL CFRVw::OnEraseBkgnd(CDC* pDC)
{
	return true;
}
