
#include "stdafx.h"
#include "resource.h"
#include "DebApp.h"
#include "IDEFrame.h"
#include "DebFrame.h"
#include ".\ideframe.h"

extern CDebFrame frame;

// CIDEFrame

CIDEFrame::CIDEFrame()
{

}

CIDEFrame::~CIDEFrame()
{

}

BEGIN_MESSAGE_MAP(CIDEFrame, CMDIFrameWnd)
	ON_WM_CREATE()

	ON_AUTO_UPDATE_CONTROL_BAR(ID_FILE_DEB)
	ON_AUTO_UPDATE_CONTROL_BAR(ID_FILE_MMAP)
	ON_AUTO_UPDATE_CONTROL_BAR(ID_FILE_CUST)
	ON_AUTO_UPDATE_CONTROL_BAR(ID_FILE_FULLREPORT)
	ON_AUTO_UPDATE_CONTROL_BAR(ID_FILE_TAILER)
	ON_COMMAND(ID_FILE_CLOSE, OnFileClose)
	ON_WM_CLOSE()
	ON_WM_DESTROY()
END_MESSAGE_MAP()

static UINT indicators[] =
{
	ID_SEPARATOR,           // status line indicator
	ID_INDICATOR_CAPS,
	ID_INDICATOR_NUM,
	ID_INDICATOR_SCRL,
};

int CIDEFrame::OnCreate(LPCREATESTRUCT lpCreateStruct)
{
	if (CMDIFrameWnd::OnCreate(lpCreateStruct) == -1)
		return -1;

	LOGFONT lf;
	GetObject(GetStockObject(DEFAULT_GUI_FONT), sizeof(LOGFONT), &lf);
	_tcscpy(lf.lfFaceName, _T(""));
	lf.lfPitchAndFamily = 0 |FIXED_PITCH;

	if (!fontFixedPitch.CreateFontIndirect(&lf))
		return -1;

	CWnd *mdiChild = GetDlgItem(AFX_IDW_PANE_FIRST);
	if (mdiChild != NULL) {
		mdiChild->ModifyStyleEx(WS_EX_CLIENTEDGE, 0, SWP_FRAMECHANGED);
	}

	//	==========
	if (false
		|| !wndDebDock.Create(LoadStr(IDR_DEB), this, ID_FILE_DEB, 0 |WS_CHILD |WS_VISIBLE |CBRS_SIZE_DYNAMIC)
	) {
		return -1;
	}
	//	==========
	if (false
		|| !wndCustDock.Create(LoadStr(IDR_CUST), this, ID_FILE_CUST, 0 |WS_CHILD |WS_VISIBLE |CBRS_SIZE_DYNAMIC)
	) {
		return -1;
	}
	//	==========
	if (false
		|| !wndFRDock.Create("Full Report", this, ID_FILE_FULLREPORT, 0 |WS_CHILD |CBRS_SIZE_DYNAMIC |WS_VISIBLE)
	) {
		return -1;
	}
	//	==========
	if (false
		|| !wndMMapDock.Create(LoadStr(IDR_MMAP), this, ID_FILE_MMAP, 0 |WS_CHILD |CBRS_SIZE_DYNAMIC)
	) {
		return -1;
	}
	//	==========
	if (false
		|| !wndTailerDock.Create(LoadStr(IDR_TAILER), this, ID_FILE_TAILER, 0 |WS_CHILD |WS_VISIBLE |CBRS_SIZE_DYNAMIC)
	) {
		return -1;
	}

	//	==========
	if (false
		|| !wndStatusBar.Create(this)
		|| !wndStatusBar.SetIndicators(indicators, sizeof(indicators)/sizeof(UINT))
	) {
		return -1;
	}

	//	==========
//	if (false
//		|| !wndMonitor.LoadFrame(IDR_MONITOR, 0 |WS_OVERLAPPEDWINDOW |WS_VISIBLE, this, NULL)
//	) {
//		return -1;
//	}

	EnableDocking(CBRS_ALIGN_ANY);

	CControlBar *barTop = GetControlBar(AFX_IDW_DOCKBAR_TOP);

	CRect rc(0, 0, 10, 10);
	barTop->ClientToScreen(&rc);

	wndDebDock.EnableDocking(CBRS_ORIENT_ANY);
	DockControlBar(&wndDebDock, AFX_IDW_DOCKBAR_TOP, rc);

	wndCustDock.EnableDocking(CBRS_ORIENT_ANY);
	DockControlBar(&wndCustDock, AFX_IDW_DOCKBAR_TOP, rc + CPoint(0, 6));

	wndFRDock.EnableDocking(CBRS_ORIENT_ANY);
	DockControlBar(&wndFRDock, AFX_IDW_DOCKBAR_TOP, rc + CPoint(6, 6));

	wndMMapDock.EnableDocking(CBRS_ORIENT_ANY);
	DockControlBar(&wndMMapDock, AFX_IDW_DOCKBAR_BOTTOM);

	wndTailerDock.EnableDocking(CBRS_ORIENT_ANY);
	DockControlBar(&wndTailerDock, AFX_IDW_DOCKBAR_BOTTOM);

#if 0
#elif 1 // tile/sprite mapfobOړI
//	wndDebDock.ShowWindow(SW_HIDE);
//	wndCustDock.ShowWindow(SW_HIDE);
//	wndFRDock.ShowWindow(SW_HIDE);
	wndMMapDock.ShowWindow(SW_HIDE);
	wndTailerDock.ShowWindow(SW_HIDE);

	DockControlBar(&wndTailerDock, AFX_IDW_DOCKBAR_RIGHT);
#endif

	AddControlBar(&wndDebDock);
	AddControlBar(&wndCustDock);
	AddControlBar(&wndMMapDock);
	AddControlBar(&wndFRDock);
	AddControlBar(&wndTailerDock);

//	LoadBarState("IDEFrame");

	return 0;
}

BOOL CIDEFrame::PreCreateWindow(CREATESTRUCT& cs)
{
	if (!CMDIFrameWnd::PreCreateWindow(cs)) return false;

	cs.style |= 0
		| WS_VSCROLL
		| WS_HSCROLL
		;

	return true;
}

void CIDEFrame::OnFileClose()
{
	ShowWindow(SW_HIDE);
}

void CIDEFrame::OnClose()
{
	ShowWindow(SW_HIDE);
}

void CIDEFrame::ActivateFrame(int nCmdShow)
{
	CWnd *ascend = GetActiveWindow();
	nCmdShow = SW_SHOWNA;
	CMDIFrameWnd::ActivateFrame(nCmdShow);
	if (ascend != NULL) ascend->BringWindowToTop();
}

void CIDEFrame::OnDestroy()
{
	CMDIFrameWnd::OnDestroy();

//	SaveBarState("IDEFrame");
}
