
#include "stdafx.h"
#include "MMapVw.h"
#include "fprintf.h"
#include "IDEFrame.h"

extern "C" void  DSP1Read8b3F();
extern "C" void  DSP2Read8b();
extern "C" void  DSP2Read8b();
extern "C" void  eramaccessbankr8();
extern "C" void  invaccessbank();
extern "C" void  memaccessbankr1648mb();
extern "C" void  memaccessbankr8();
extern "C" void  memaccessbankr848mb();
extern "C" void  memaccessbankr8sdd1();
extern "C" void  memaccessspc7110r8();
extern "C" void  membank0r8();
extern "C" void  membank0r8chip();
extern "C" void  membank0r8inv();
extern "C" void  membank0r8ram();
extern "C" void  membank0r8ramSA1();
extern "C" void  membank0r8reg();
extern "C" void  membank0r8rom();
extern "C" void  membank0r8romram();
extern "C" void  regaccessbankr8();
extern "C" void  regaccessbankr8SA1();
extern "C" void  SA1RAMaccessbankr8();
extern "C" void  SA1RAMaccessbankr8b();
extern "C" void  setaaccessbankr8();
extern "C" void  setaaccessbankr8a();
extern "C" void  sfxaccessbankr8();
extern "C" void  sfxaccessbankr8b();
extern "C" void  sfxaccessbankr8c();
extern "C" void  sfxaccessbankr8d();
extern "C" void  sramaccessbankr8();
extern "C" void  wramaccessbankr8();
extern "C" void  sramaccessbankr8s();

extern CIDEFrame frameide;

// CMMapVw

CMMapVw::CMMapVw()
{
}

CMMapVw::~CMMapVw()
{
}

BEGIN_MESSAGE_MAP(CMMapVw, CListView)
	ON_NOTIFY_REFLECT(LVN_GETDISPINFO, OnLvnGetdispinfo)
	ON_WM_TIMER()
	ON_NOTIFY_REFLECT(LVN_ODFINDITEM, OnLvnOdfinditem)
END_MESSAGE_MAP()

BOOL CMMapVw::PreCreateWindow(CREATESTRUCT& cs)
{
	if (!CListView::PreCreateWindow(cs)) return false;

	cs.style |= 0
		| LVS_REPORT
		| LVS_SHOWSELALWAYS
		| LVS_OWNERDATA
		| LVS_NOSORTHEADER
		| LVS_SINGLESEL
		;
	return true;
}

#define LC GetListCtrl()

void CMMapVw::OnInitialUpdate()
{
	CListView::OnInitialUpdate();

	LC.SetItemCount(256);

	LC.SetExtendedStyle(LC.GetExtendedStyle() |LVS_EX_FULLROWSELECT);

	while (LC.DeleteColumn(0));

	LC.InsertColumn(0, "Bank", LVCFMT_LEFT, 35);
	LC.InsertColumn(1, "0000-7fff", LVCFMT_LEFT, 100);
	LC.InsertColumn(2, "8000-ffff", LVCFMT_LEFT, 100);
	LC.InsertColumn(3, "bankr8", LVCFMT_LEFT, 133);

	LC.SetBkColor(RGB(0, 0, 88));
	LC.SetTextColor(RGB(255, 255, 255));
	LC.SetTextBkColor(RGB(0, 0, 88));

	LC.SetFont(frameide.GetFont());

	KillTimer(0x0101);
	SetTimer(0x0101, 500, NULL);
}

extern "C" DWORD snesmmap[256]; // lo
extern "C" DWORD snesmap2[256]; // hi
extern "C" BYTE wramdataa[];
extern "C" BYTE ram7fa[];
extern "C" BYTE srama[65536*2];
extern "C" BYTE sfxramdata[];
extern "C" BYTE SA1RAMArea[];
extern "C" BYTE newgfx16b;
extern "C" BYTE Sup48mbit;
extern "C" BYTE Sup16mbit;
extern "C" DWORD memtabler8[256];

void CMMapVw::OnLvnGetdispinfo(NMHDR *pNMHDR, LRESULT *pResult)
{
	NMLVDISPINFO *pDispInfo = reinterpret_cast<NMLVDISPINFO*>(pNMHDR);
	//
	LVITEM &r = pDispInfo->item;
	if (r.mask & LVIF_TEXT) {
		text = "?";
		switch (r.iSubItem) {
		case 0:
			{
				text.Format("%02X", 0U +r.iItem);
				break;
			}
		case 1:
		case 2:
			{
				BYTE xx = (r.iSubItem == 1) ? 0 : 1;
				BYTE yy = (BYTE)r.iItem;

				DWORD sizerom = 4*1024*1024;
				if (Sup48mbit)
					sizerom = 6*1024*1024;

				DWORD_PTR addr;
				if (xx == 0) {
					addr = snesmap2[yy];
				} else {
					addr = snesmmap[yy] + 0x8000;
				}

				prior[yy][xx] = addr;

				DWORD_PTR x;

#define FORMADDR(X) \
						x /= 1024;							\
						if (x < 1000) {						\
							text.Format(##X "%5uk"			\
								, (UINT)(x % 1000)			\
								);							\
						} else {							\
							text.Format(##X "%u,%03uk"		\
								, (UINT)(x / 1000)			\
								, (UINT)(x % 1000)			\
								);							\
						}

				// mapped to ROM
				x = addr - (DWORD_PTR)romdata;
				if (false);
				else if (Sup48mbit) {
					if (false);
					else if (x < 4096*1024) {
						FORMADDR("ROM  ");
						break;
					}
					else if (x < 4096*1024+32768*2) {
						x -= 4096*1024;
						FORMADDR("ERAM ");
						break;
					}
					else if (x < 4096*1024+32768*2+2048*1024) {
						x -= 32768*2;
						FORMADDR("ROM  ");
						break;
					}
					else if (x < 4096*1024+32768*2+2048*1024+4096) {
						x -= 4096*1024+32768*2+2048*1024;
						FORMADDR("EREG ");
						break;
					}
				}
				else if (Sup16mbit) {
					if (false);
					else if (x < 4096*1024) {
						FORMADDR("ROM  ");
						break;
					}
					else if (x < 4096*1024+32768*2) {
						x -= 4096*1024;
						FORMADDR("ERAM ");
						break;
					}
					else if (x < 4096*1024+32768*2+4096) {
						x -= 4096*1024+32768*2;
						FORMADDR("EREG ");
						break;
					}
				}
				else {
					if (false);
					else if (x < 2048*1024) {
						FORMADDR("ROM  ");
						break;
					}
					else if (x < 2048*1024+32768*2) {
						x -= 2048*1024;
						FORMADDR("SA-1 ");
						break;
					}
					else if (x < 2048*1024+32768*2+4096) {
						x -= 2048*1024+32768*2;
						FORMADDR("EREG ");
						break;
					}
				}
				if (x < sizerom) {
					x /= 1024;
					if (x < 1000) {
						text.Format("ROM  %5uk"
							, (UINT)(x % 1000)
							);
					} else {
						text.Format("ROM  %u,%03uk"
							, (UINT)(x / 1000)
							, (UINT)(x % 1000)
							);
					}
					break;
				}
				// ROM  0,234k
				// RAM(L)1234k
				// RAM(H)1234k

				// mapped to RAM
				x = addr - (DWORD_PTR)wramdataa;
				if (x < 65536) {
					text.Format("RAM(L)%4uk", (UINT)(x / 1024));
					break;
				}
				x = addr - (DWORD_PTR)ram7fa;
				if (x < 65536) {
					text.Format("RAM(H)%4uk", (UINT)(x / 1024));
					break;
				}
				x = addr - (DWORD_PTR)srama;
				if (x < 131072) {
					text.Format("SRAM %5uk", (UINT)(x / 1024));
					break;
				}
				x = addr - (DWORD_PTR)sfxramdata;
				if (x < 1024*1024*4) {
					x /= 1024;
					if (x < 1000) {
						text.Format("SFX  %5uk"
							, (UINT)(x % 1000)
							);
					} else {
						text.Format("SFX  %u,%03uk"
							, (UINT)(x / 1000)
							, (UINT)(x % 1000)
							);
					}
					break;
				}
				break;
			}
		case 3:
			{
				void (*addr)(void) = (void (*)())(memtabler8[r.iItem & 255]);
#define FX(F,N) else if (addr == &F) text = #F;

				if (false);
				
				FX(DSP1Read8b3F, "DSP1")
				FX(DSP2Read8b, "DSP2")
				FX(eramaccessbankr8, "eramaccess")
				FX(invaccessbank, "invaccess")
				FX(memaccessbankr8, "memaccess")
				FX(memaccessbankr848mb, "memaccess.48mb")
				FX(memaccessbankr8sdd1, "memaccess.sdd1")
				FX(memaccessspc7110r8, "memaccessspc7110")
				FX(membank0r8, "mem")
				FX(membank0r8chip, "mem.chip")
				FX(membank0r8inv, "mem.inv")
				FX(membank0r8ram, "mem.ram")
				FX(membank0r8ramSA1, "membank.ramSA1")
				FX(membank0r8reg, "mem.reg")
				FX(membank0r8rom, "mem.rom")
				FX(membank0r8romram, "mem.romram")
				FX(regaccessbankr8, "regaccess")
				FX(regaccessbankr8SA1, "regaccess.SA1")
				FX(SA1RAMaccessbankr8, "SA1RAMaccess")
				FX(SA1RAMaccessbankr8b, "SA1RAMaccess.b")
				FX(setaaccessbankr8, "setaaccess")
				FX(setaaccessbankr8a, "setaaccess.a")
				FX(sfxaccessbankr8, "sfxaccess")
				FX(sfxaccessbankr8b, "sfxaccess.b")
				FX(sfxaccessbankr8c, "sfxaccess.c")
				FX(sfxaccessbankr8d, "sfxaccess.d")
				FX(sramaccessbankr8, "sramaccess")
				FX(wramaccessbankr8, "wramaccess")
				FX(sramaccessbankr8s, "sramaccess.s")
				

				break;
			}
		}
		r.pszText = const_cast<LPSTR>((LPCSTR)text);
	}
	//
	*pResult = 0;
}

void CMMapVw::OnTimer(UINT nIDEvent)
{
	if (nIDEvent == 0x0101) {
		BYTE y0 = LC.GetTopIndex();
		BYTE y1 = (BYTE)(y0 + LC.GetCountPerPage() - 1);
		while (true) {
			for (BYTE xx = 0; xx < 2; xx++) {
				DWORD_PTR addr;
				if (xx == 0) {
					addr = snesmap2[y0];
				} else {
					addr = snesmmap[y0] + 0x8000;
				}
				if (prior[y0][xx] != addr) {
					if (y0 == y1) prior[y0][xx] = addr;
					Invalidate();
					return;
				}
			}
			if (y0 == y1) break;
			y0++;
		}
		return;
	}

	CListView::OnTimer(nIDEvent);
}

void CMMapVw::OnLvnOdfinditem(NMHDR *pNMHDR, LRESULT *pResult)
{
	LPNMLVFINDITEM pFindInfo = reinterpret_cast<LPNMLVFINDITEM>(pNMHDR);
	*pResult = -1;
	//
	LVFINDINFO &r = pFindInfo->lvfi;
	if (r.flags & LVFI_STRING && pFindInfo->iStart < 256U) {
		char c[10];
		int n = strlen(r.psz);
		UINT ox = (pFindInfo->iStart);
		UINT cx = (r.flags & LVFI_WRAP)
			? (256)
			: (256 - ox)
			;
		for (UINT x = 0; x < cx; x++) {
			sprintf(c, "%02X", (ox + x) & 255);
			if (stricmp(c, r.psz) == 0) {
				*pResult = (ox + x) & 255;
				return;
			}
		}
		if (true || r.flags & LVFI_PARTIAL) {
			for (UINT x = 0; x < cx; x++) {
				sprintf(c, "%02X", (ox + x) & 255);
				if (strnicmp(c, r.psz, n) == 0) {
					*pResult = (ox + x) & 255;
					return;
				}
			}
		}
	}
	//
}
