
#include "stdafx.h"
#include "resource.h"
#include "ScriptStatDlg.h"
#include "ScriptServer.h"
#include "fprintf.h"

CScriptStatDlg::CScriptStatDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CScriptStatDlg::IDD, pParent)
{
}

CScriptStatDlg::~CScriptStatDlg()
{
}

void CScriptStatDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	DDX_Control(pDX, IDC_LIST, m_wndList);
}

BEGIN_MESSAGE_MAP(CScriptStatDlg, CDialog)
END_MESSAGE_MAP()

BOOL CScriptStatDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	m_wndList.InsertColumn(0, "Stat", LVCFMT_LEFT, 50);
	m_wndList.InsertColumn(1, "Scripto", LVCFMT_LEFT, 200);

	m_wndList.SetExtendedStyle(m_wndList.GetExtendedStyle() |LVS_EX_FULLROWSELECT);

	m_wndList.DeleteAllItems();

	size_t i;
	for (i = 0; i < MAX_SCRIPTO; i++) {
		CScriptolet &r = scriptoServer.scrlet[i];
		int scrlets = r.GetState();
		CString strState;
		switch (scrlets) {
		case SCRLETS_OK:
			strState = "OK"; break;
		case SCRLETS_BROKEN:
			strState = "Down"; break;
		case SCRLETS_INTERNAL_ERR:
			strState = "Internal error"; break;
		case SCRLETS_UNKNOWN:
			strState = "Unknown"; break;
		default:
			continue;
		}
		m_wndList.InsertItem(i, strState);
		m_wndList.SetItemText(i, 1, r.strScriptoName);
	}

	m_wndList.SetColumnWidth(1, LVSCW_AUTOSIZE);

	return TRUE;  // return TRUE unless you set the focus to a control
	// O : OCX vpeB y[W͕K FALSE Ԃ܂B
}
