
#include "stdafx.h"
#include "resource.h"
#include "ScriptoDlg.h"
#include "fprintf.h"
#include "DebApp.h"

using namespace OSP;

CScriptoDlg::CScriptoDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CScriptoDlg::IDD, pParent)
{
}

CScriptoDlg::~CScriptoDlg()
{
}

void CScriptoDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	DDX_Control(pDX, IDC_LIST, m_wndList);
}

BEGIN_MESSAGE_MAP(CScriptoDlg, CDialog)
	ON_BN_CLICKED(IDC_BUTTON_EDIT, OnBnClickedButtonEdit)
	ON_BN_CLICKED(IDC_BUTTON_RELOAD, OnBnClickedButtonReload)
END_MESSAGE_MAP()

namespace {

bool CheckEnjineOf(LPCWSTR psz)
{
	IActiveScriptPtr pUnkScripto;

	HRESULT hr = pUnkScripto.CreateInstance(psz);
	if (hr == S_OK)
		return true;
	return false;
}

};

BOOL CScriptoDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	CWaitCursor wc;

	m_wndList.SetExtendedStyle(m_wndList.GetExtendedStyle() |LVS_EX_FULLROWSELECT);

	m_wndList.InsertColumn(0, "Enjine", LVCFMT_LEFT, 80);
	m_wndList.InsertColumn(1, "Scripto", LVCFMT_LEFT, 200);

	SendDlgItemMessage(IDC_CHECK1, BM_SETCHECK, CheckEnjineOf(L"JScript") ? BST_CHECKED : BST_UNCHECKED);
	SendDlgItemMessage(IDC_CHECK2, BM_SETCHECK, CheckEnjineOf(L"VBScript") ? BST_CHECKED : BST_UNCHECKED);
	SendDlgItemMessage(IDC_CHECK3, BM_SETCHECK, CheckEnjineOf(L"PerlScript") ? BST_CHECKED : BST_UNCHECKED);
	SendDlgItemMessage(IDC_CHECK4, BM_SETCHECK, CheckEnjineOf(L"RubyScript") ? BST_CHECKED : BST_UNCHECKED);
	SendDlgItemMessage(IDC_CHECK5, BM_SETCHECK, CheckEnjineOf(L"Python") ? BST_CHECKED : BST_UNCHECKED);

	Rewind();

	return TRUE;  // return TRUE unless you set the focus to a control
	// O : OCX vpeB y[W͕K FALSE Ԃ܂B
}

namespace {

bool RunAt(CString strApp, CString strCmd, CString strDir, bool waitExit)
{
	STARTUPINFO si;
	ZeroMemory(&si, sizeof(si));
	si.cb = sizeof(si);
	PROCESS_INFORMATION pi;
	ZeroMemory(&pi, sizeof(pi));

	BOOL r = CreateProcess(
		strApp.IsEmpty() ? (LPCTSTR)NULL : strApp,
		const_cast<LPTSTR>((LPCTSTR)strCmd),
		NULL,
		NULL,
		false,
		0,
		NULL,
		strDir,
		&si,
		&pi
		);
	if (!r) return false;

	if (waitExit) {
		WaitForSingleObject(pi.hThread, INFINITE);
		WaitForSingleObject(pi.hProcess, INFINITE);
	}

	CloseHandle(pi.hProcess);
	CloseHandle(pi.hThread);

	return true;
}

CString GetAppDir()
{
	return OSP_GetDir(OSP_GetModuleFileName(NULL));
}

CString GetCnfFile()
{
	return OSP_JoinPath(GetAppDir(), "fprintf.ini");
}

};

void CScriptoDlg::OnBnClickedButtonEdit()
{
	CString strDir = GetAppDir();
	RunAt("", "NOTEPAD.exe \"" + GetCnfFile() + "\"", strDir, false);
}

void CScriptoDlg::OnBnClickedButtonReload()
{
	static_cast<CDebApp *>(AfxGetApp())->LoadCnf();

	Rewind();
}

void CScriptoDlg::Rewind()
{
	m_wndList.DeleteAllItems();

	for (size_t i = 0; i < scriptoVec.size(); i++) {
		int r = m_wndList.InsertItem(i, scriptoVec[i].strEngine);
		if (r < 0) continue;
		m_wndList.SetItemText(r, 1, scriptoVec[i].strFile);
	}
	m_wndList.SetColumnWidth(1, LVSCW_AUTOSIZE_USEHEADER);
}
