
#pragma once

class CServer : public CCmdTarget
{
public:
	// 
	CServer();
	// 
	virtual ~CServer();

	// 
	IActiveScriptSite *GetMySite(bool fAddRef = true);
	// 
	LPDISPATCH Message(LPCSTR pszMessage, LPCTSTR pszSrc, int severity);

	// 
	virtual void OnFinalRelease();

	// 
	LPDISPATCH U_Message(LPCSTR pszMessage, LPCTSTR pszSrc, int severity);
	LPDISPATCH U_AddCodeBreak(int addr);
	void U_RemoveCodeBreak(int addr);
	DWORD U_ReadMem8(int addr);
	DWORD U_ReadMem16(int addr);
	DWORD U_ReadMem32(int addr);
	int U_GetReg(int what);
	void U_seterr(DWORD);
	WORD U_xa();
	BYTE U_xdb();
	BYTE U_xpb();
	WORD U_xs();
	WORD U_xd();
	WORD U_xx();
	WORD U_xy();
	BYTE U_xp();
	BSTR U_CasetteName();
	BOOL U_CaptureMemoryToFile(DWORD addrFrom, DWORD addrTo, LPCTSTR pszNewFile);
	BSTR U_sprintf(LPCOLESTR format, VARIANT &params);
	void U_EnableSingleStep();
	void U_DisableSingleStep();
	void U_EnablePostProcess();
	void U_DisablePostProcess();
	DWORD U_PrevAddr();
	VARIANT U_CaptureMemoryToVar(DWORD addrFrom, DWORD addrTo);

protected:
	// 
	DECLARE_MESSAGE_MAP()
	DECLARE_DISPATCH_MAP()
	DECLARE_INTERFACE_MAP()

	BEGIN_INTERFACE_PART(MySite, IActiveScriptSite)
		STDMETHOD(GetLCID)(LCID *);
		STDMETHOD(GetItemInfo)(LPCOLESTR, DWORD, IUnknown **, ITypeInfo **);
		STDMETHOD(GetDocVersionString)(BSTR *);
		STDMETHOD(OnScriptTerminate)(const VARIANT *, const EXCEPINFO *);
		STDMETHOD(OnStateChange)(SCRIPTSTATE);
		STDMETHOD(OnScriptError)(IActiveScriptError *);
		STDMETHOD(OnEnterScript)();
		STDMETHOD(OnLeaveScript)();
	END_INTERFACE_PART(MySite)

	BEGIN_INTERFACE_PART(MySiteWindow, IActiveScriptSiteWindow)
		STDMETHOD(GetWindow)(HWND *phwnd);
		STDMETHOD(EnableModeless)(BOOL fEnable);
	END_INTERFACE_PART(MySiteWindow)

};

extern CServer serverobj;
