
#include "stdafx.h"
#include "resource.h"
#include "ServerMsgob.h"
#include "IDEFrame.h"
#include "OleByteBin.h"
#include "CustReport.h"

extern CIDEFrame frameide;

extern "C" BYTE cgram[];

// CServerMsgob

CServerMsgob::CServerMsgob(int refid)
{
	this->refid = refid;

	EnableAutomation();
}

CServerMsgob::~CServerMsgob()
{

}

void CServerMsgob::OnFinalRelease()
{
	CCmdTarget::OnFinalRelease();
}

BEGIN_DISPATCH_MAP(CServerMsgob, CCmdTarget)
	DISP_FUNCTION(CServerMsgob, "Add4bppImage", U_Add4bppImage, VT_BOOL, VTS_VARIANT VTS_I2 VTS_I4 VTS_I4)
	DISP_FUNCTION(CServerMsgob, "AddString", U_AddString, VT_BOOL, VTS_BSTR)
	DISP_FUNCTION(CServerMsgob, "AddBR", U_AddBR, VT_BOOL, VTS_NONE)
END_DISPATCH_MAP()

/*//////////////////////////////////////////////////////////////////////////
// Internally, published features
//////////////////////////////////////////////////////////////////////////*/

BOOL CServerMsgob::U_Add4bppImage(const VARIANT &vt, SHORT palette, LONG _cx, LONG _cy)
{
	SizeBuff sb;
	if (COleByteBin().MkFromVt(vt, sb)) {
		CCustReport *report = frameide.wndCustDock.frame.vw.FindReport(refid, false);
		if (report != NULL) {
			const UINT cx = _cx, cy = _cy;
			const UINT pitch = ((cx + 1) >> 1);
			const UINT minsize = pitch * cy;
			if (minsize <= (UINT)sb.GetSize()) {
				CM_Record rec;
				CM_Image &img = rec.imgo;
				rec.cmr = CM_r_Image;
				if (img.Alloc(cx, cy)) {
					//
					UINT x, y;

					BYTE *pSrcVert = sb.GetData();
					for (y = 0; y < cy; y++) {
						BYTE *pSrcHorz = pSrcVert;
						for (x = 0; x < cx; ) {
							BYTE xx = *pSrcHorz;
							img.SetPixel(x, y, xx / 16);
							x++;
							img.SetPixel(x, y, xx % 16);
							x++;
							pSrcHorz++;
						}
						pSrcVert += pitch;
					}
					//
					WORD *psrc = &((WORD *)cgram)[16 * (palette & 15)];
					for (x = 0; x < 16; x++) {
						WORD v = *psrc;
						COLORREF clr = RGB(
							(int)(255.0 / 31.0 * ((v >> 0) & 31)),
							(int)(255.0 / 31.0 * ((v >> 5) & 31)),
							(int)(255.0 / 31.0 * ((v >>10) & 31))
							);
						img.clro()[x].rgbRed   = GetRValue(clr);
						img.clro()[x].rgbGreen = GetGValue(clr);
						img.clro()[x].rgbBlue  = GetBValue(clr);
						img.clro()[x].rgbReserved = 0;
						psrc++;
					}
					//
					report->report.rs.Add(rec);

					frameide.wndCustDock.frame.vw.FindReport(refid, true);
					return true;
				}
				else AfxThrowMemoryException();
			}
			else AfxThrowOleDispatchException(1, "ERR! Image size is too short");
		}
		//else AfxThrowOleDispatchException(1, "ERR! Log entry is already disposeds");
	}
	else AfxThrowOleDispatchException(1, "ERR! Unknown format of input variable");
	return false;
}

BOOL CServerMsgob::U_AddString(LPCTSTR psz)
{
	CCustReport *report = frameide.wndCustDock.frame.vw.FindReport(refid, false);
	if (report != NULL) {
		//
		CM_Record rec;
		rec.cmr = CM_r_Str;
		rec.text = psz;
		//
		report->report.rs.Add(rec);

		frameide.wndCustDock.frame.vw.FindReport(refid, true);
		return true;
	}
	//else AfxThrowOleDispatchException(1, "ERR! Log entry is already disposeds");

	return false;
}

BOOL CServerMsgob::U_AddBR()
{
	CCustReport *report = frameide.wndCustDock.frame.vw.FindReport(refid, false);
	if (report != NULL) {
		//
		CM_Record rec;
		rec.cmr = CM_r_BR;
		//
		report->report.rs.Add(rec);

		frameide.wndCustDock.frame.vw.FindReport(refid, true);
		return true;
	}
	//else AfxThrowOleDispatchException(1, "ERR! Log entry is already disposeds");

	return false;
}
