
#include "stdafx.h"
#include "resource.h"
#include "TailerFrame.h"
#include ".\tailerframe.h"

// CTailerFrame

CTailerFrame::CTailerFrame()
{
}

CTailerFrame::~CTailerFrame()
{
}

BEGIN_MESSAGE_MAP(CTailerFrame, CFrameWnd)
	ON_WM_CREATE()
	ON_COMMAND_EX(ID_BUTTON_TILEMAP, OnButtonTilemap)
	ON_COMMAND_EX(ID_BUTTON_BG1, OnButtonTilemap)
	ON_COMMAND_EX(ID_BUTTON_BG2, OnButtonTilemap)
	ON_COMMAND_EX(ID_BUTTON_BG3, OnButtonTilemap)
	ON_COMMAND_EX(ID_BUTTON_BG4, OnButtonTilemap)
//	ON_COMMAND_EX(ID_BUTTON_DSP2, OnButtonTilemap)
	ON_WM_SIZE()
	ON_UPDATE_COMMAND_UI(ID_BUTTON_TILEMAP, OnUpdateButtonTilemap)
	ON_UPDATE_COMMAND_UI(ID_BUTTON_BG1, OnUpdateButtonTilemap)
	ON_UPDATE_COMMAND_UI(ID_BUTTON_BG2, OnUpdateButtonTilemap)
	ON_UPDATE_COMMAND_UI(ID_BUTTON_BG3, OnUpdateButtonTilemap)
	ON_UPDATE_COMMAND_UI(ID_BUTTON_BG4, OnUpdateButtonTilemap)
//	ON_UPDATE_COMMAND_UI(ID_BUTTON_DSP2, OnUpdateButtonTilemap)
	ON_MESSAGE(WM_SETMESSAGESTRING, OnSetMessageString)
	ON_MESSAGE(WM_POPMESSAGESTRING, OnPopMessageString)
END_MESSAGE_MAP()

LRESULT CTailerFrame::OnPopMessageString(WPARAM wParam, LPARAM lParam)
{
	CFrameWnd *pMainWnd = GetTopLevelFrame();
	if (pMainWnd != NULL) {
		const MSG *m = GetCurrentMessage();
		return pMainWnd->SendMessage(m->message, m->wParam, m->lParam);
	}
	return CFrameWnd::OnPopMessageString(wParam, lParam);
}

LRESULT CTailerFrame::OnSetMessageString(WPARAM wParam, LPARAM lParam)
{
	CFrameWnd *pMainWnd = GetTopLevelFrame();
	if (pMainWnd != NULL) {
		const MSG *m = GetCurrentMessage();
		return pMainWnd->SendMessage(m->message, m->wParam, m->lParam);
	}
	return CFrameWnd::OnSetMessageString(wParam, lParam);
}
	
BOOL CTailerFrame::OnCreateClient(LPCREATESTRUCT lpcs, CCreateContext* pContext)
{
	if (!vw.Create(NULL, NULL, AFX_WS_DEFAULT_VIEW, CRect(0, 0, 0, 0), this, AFX_IDW_PANE_FIRST, pContext))
		return false;
	if (!vw2.Create(NULL, NULL, AFX_WS_DEFAULT_VIEW, CRect(0, 0, 0, 0), this, AFX_IDW_PANE_FIRST, pContext))
		return false;

	return true;
}

BOOL CTailerFrame::PreCreateWindow(CREATESTRUCT& cs)
{
	if (!CFrameWnd::PreCreateWindow(cs)) return false;

	cs.dwExStyle &= ~WS_EX_CLIENTEDGE;
	cs.hMenu = NULL;
	return true;
}

int CTailerFrame::OnCreate(LPCREATESTRUCT lpCreateStruct)
{
	if (CFrameWnd::OnCreate(lpCreateStruct) == -1)
		return -1;

	//	===================================
	if (false
		|| !wndToolBar.CreateEx(this, 0 |TBSTYLE_FLAT, 0 |WS_CHILD |WS_VISIBLE |CBRS_SIZE_DYNAMIC |CBRS_ALIGN_LEFT |CBRS_GRIPPER |CBRS_TOOLTIPS, CRect(0,0,0,0), AFX_IDW_TOOLBAR)
		|| !wndToolBar.LoadToolBar(IDR_TAILER)
	) {
		return -1;
	}
	wndToolBar.SetHeight(12 + GetSystemMetrics(SM_CYSMICON));

	//	===================================
	EnableDocking(CBRS_ALIGN_ANY);

	wndToolBar.EnableDocking(CBRS_ALIGN_ANY);
	DockControlBar(&wndToolBar, AFX_IDW_DOCKBAR_LEFT);

	OnButtonTilemap(ID_BUTTON_TILEMAP);
	return 0;
}

BOOL CTailerFrame::OnButtonTilemap(UINT nID)
{
	CWnd *pNewView = NULL;
	switch (nID) {
		case ID_BUTTON_DSP2:	pNewView = &vw2; break;
		case ID_BUTTON_TILEMAP:	pNewView = &vw, vw.tvt = vw.tvtsprite; break;
		case ID_BUTTON_BG1:		pNewView = &vw, vw.tvt = vw.tvtbg1; break;
		case ID_BUTTON_BG2:		pNewView = &vw, vw.tvt = vw.tvtbg2; break;
		case ID_BUTTON_BG3:		pNewView = &vw, vw.tvt = vw.tvtbg3; break;
		case ID_BUTTON_BG4:		pNewView = &vw, vw.tvt = vw.tvtbg4; break;
	}
	if (pNewView != NULL) {
		vw.ShowWindow(&vw == pNewView ? SW_SHOW : SW_HIDE);
		vw2.ShowWindow(&vw2 == pNewView ? SW_SHOW : SW_HIDE);

		pNewView->SetWindowPos(&CWnd::wndBottom, 0, 0, 0, 0, 0 |SWP_NOMOVE |SWP_NOSIZE);
	}
	RecalcLayout();
	return true;
}

void CTailerFrame::OnSize(UINT nType, int cx, int cy)
{
	CFrameWnd::OnSize(nType, cx, cy);
}

void CTailerFrame::OnUpdateButtonTilemap(CCmdUI *pCmdUI)
{
	CWnd *pNewView = NULL;
	bool here = true;
	switch (pCmdUI->m_nID) {
		case ID_BUTTON_DSP2:	pNewView = &vw2; break;
		case ID_BUTTON_TILEMAP:	pNewView = &vw, here = (vw.tvt == vw.tvtsprite); break;
		case ID_BUTTON_BG1:		pNewView = &vw, here = (vw.tvt == vw.tvtbg1); break;
		case ID_BUTTON_BG2:		pNewView = &vw, here = (vw.tvt == vw.tvtbg2); break;
		case ID_BUTTON_BG3:		pNewView = &vw, here = (vw.tvt == vw.tvtbg3); break;
		case ID_BUTTON_BG4:		pNewView = &vw, here = (vw.tvt == vw.tvtbg4); break;
	}

	pCmdUI->SetRadio((pNewView != NULL) && here && pNewView->IsWindowVisible());
}
