
#include "stdafx.h"
#include "resource.h"
#include "TailerVw.h"
#include "IDEFrame.h"
#include "Util.h"
#include "CompatDC.h"

extern CIDEFrame frameide;

// CTailerVw

CTailerVw::CTailerVw()
{
}

CTailerVw::~CTailerVw()
{
}

BEGIN_MESSAGE_MAP(CTailerVw, CView)
	ON_WM_ERASEBKGND()
	ON_WM_CREATE()
	ON_WM_TIMER()
END_MESSAGE_MAP()

extern "C" WORD bg1objptr, bg1ptr, bg1ptrb, bg1ptrc, bg1ptrd;
extern "C" BYTE bg1scsize;

extern "C" WORD bg2objptr, bg2ptr, bg2ptrb, bg2ptrc, bg2ptrd;
extern "C" BYTE bg2scsize;

extern "C" WORD bg3objptr, bg3ptr, bg3ptrb, bg3ptrc, bg3ptrd;
extern "C" BYTE bg3scsize;

extern "C" WORD bg4objptr, bg4ptr, bg4ptrb, bg4ptrc, bg4ptrd;
extern "C" BYTE bg4scsize;

extern "C" BYTE wramdataa[], oamram[], cgram[];
extern "C" BYTE *vram;

extern "C" DWORD objptr;
extern "C" BYTE objsize1;

extern "C" DWORD objptrn;
extern "C" BYTE objsize2;
extern "C" BYTE bgtilesz;
extern "C" BYTE bgmode;

static void hexbin(CString &text, UINT pos, BYTE *binary, BYTE cy = 4) {
	char texto[(3*16+2)*32];
	int texti = 0;
	static BYTE hex[] = {"0123456789ABCDEF"};
	for (BYTE y = 0; y < cy; y++) {
		for (BYTE x = 0; x < 16; x++) {
			BYTE v = binary[pos];
			texto[texti] = hex[v / 16]; texti++;
			texto[texti] = hex[v & 15]; texti++;
			texto[texti] = ' '; texti++;

			pos = (pos + 1) & 0xFFFF;
		}
		texto[texti] = '\n'; texti++;
	}
	texto[texti] = 0;
	text += texto;
}

void rendertext(CDC *dc, CDC &dcMem, CRect rc, CString text)
{
	const UINT bcx = 512;
	const UINT bcy = 1024;

	CRect rect(0, 0, bcx, bcy);
	CSize sizetotal(0, 0);
	LPCTSTR psz0 = text;
	while (psz0 != NULL && *psz0 != 0) {
		LPCTSTR psz1 = _tcschr(psz0, '\n');
		if (psz1 == NULL)
			psz1 = _tcschr(psz0, 0);

		CSize size = dcMem.GetOutputTextExtent(psz0, psz1-psz0 +1);

		rect.top = sizetotal.cy;

		dcMem.ExtTextOut(0, sizetotal.cy, 0 |ETO_CLIPPED |ETO_OPAQUE, &rect, psz0, psz1-psz0, NULL);

		psz0 = psz1;
		if (*psz1 != 0) psz0++;

		sizetotal.cx = max(sizetotal.cx, size.cx);
		sizetotal.cy += size.cy;
	}

	rc.right = rc.left + sizetotal.cx;
	rc.bottom = rc.top + sizetotal.cy;

	dc->BitBlt(rc.left, rc.top, sizetotal.cx, sizetotal.cy, &dcMem, 0, 0, SRCCOPY);
	dc->ExcludeClipRect(&rc);
}

// objsize1
//  1 = 16 pix
//  4 = 32 pix
// 16 = 64 pix

void CTailerVw::renderBg(CDC *pDC)
{

}

void CTailerVw::renderSprite(CDC *pDC)
{
	const UINT bcx = 256;
	const UINT bcy = 256;

	static BYTE bits[bcx*bcy];
	static BYTE bibuff[40 + 4 * 256];

	BITMAPINFO &bi = (BITMAPINFO &)*bibuff;
	ZeroMemory(bibuff, sizeof(bibuff));
	bi.bmiHeader.biSize = sizeof(bi.bmiHeader);
	bi.bmiHeader.biWidth = bcx;
	bi.bmiHeader.biHeight = bcy;
	bi.bmiHeader.biPlanes = 1;
	bi.bmiHeader.biBitCount = 8;

	{
		BYTE color = 0;
		do {
			SNESUtil::getPaletteAt(color, bi.bmiColors[color]);
			color++;
		} while (color != 255);
	}

	CRect rc;
	GetClientRect(rc);
	CRect rc0 = rc;

	rc.DeflateRect(1, 1);

	TEXTMETRIC tm;

	CCompatDC dcMem(pDC);
	dcMem.SaveDC();
	dcMem.SelectObject(&bmoffscr);
	dcMem.SelectObject(&frameide.fontFixedPitch);
	dcMem.SetBkColor(RGB(0,0,88));
	dcMem.SetTextColor(RGB(255,255,255));
	dcMem.GetTextMetrics(&tm);
	//

	static const LPCSTR tablescsize[] = {
		" *0  ",
		" *1  ",
		" *2  ",
		" *3  ",
		" *4  ",
		" *5  ",
		" *6  ",
		" *7  ",
	};
	static const LPCSTR tabletilesz[] = {
		" 8x8 ",
		" *1  ",
	};

	typedef struct bpptable
	{	char bg1bpp;
		char bg2bpp;
		char bg3bpp;
		char bg4bpp;
	}	bpptable;

	bpptable bgmode2bgx[8] = {
		-1,-1,-1,-1, // mode 0
		 4, 4, 2, 0, // mode 1
		-1,-1,-1,-1, // mode 2
		-1,-1,-1,-1, // mode 3
		-1,-1,-1,-1, // mode 4
		-1,-1,-1,-1, // mode 5
		-1,-1,-1,-1, // mode 6
		-1,-1,-1,-1, // mode 7
	};

	CString text;
	text.Format(
		"   |addr1|size1|addr2|size2|bpp| \n"
		"---+-----+-----+-----+-----+---+ \n"
		"BG1|%04X |%-5s|%04X |%-5s| %2d| \n"
		"BG2|%04X |%-5s|%04X |%-5s| %2d| \n"
		"BG3|%04X |%-5s|%04X |%-5s| %2d| \n"
		"BG4|%04X |%-5s|%04X |%-5s| %2d| \n"
		"OBJ|%04X | *%-2u |%04X | *%-2u |  4| \n"
		"\n"
		"Mode(%x)\n"
		, 0U +bg1objptr, tablescsize[bg1scsize & 7], 0U +bg1ptr, tabletilesz[(bgtilesz & 1) ? 1 : 0], 0 +bgmode2bgx[bgmode & 7].bg1bpp
		, 0U +bg2objptr, tablescsize[bg2scsize & 7], 0U +bg2ptr, tabletilesz[(bgtilesz & 2) ? 1 : 0], 0 +bgmode2bgx[bgmode & 7].bg2bpp
		, 0U +bg3objptr, tablescsize[bg3scsize & 7], 0U +bg3ptr, tabletilesz[(bgtilesz & 4) ? 1 : 0], 0 +bgmode2bgx[bgmode & 7].bg3bpp
		, 0U +bg4objptr, tablescsize[bg4scsize & 7], 0U +bg4ptr, tabletilesz[(bgtilesz & 8) ? 1 : 0], 0 +bgmode2bgx[bgmode & 7].bg4bpp
		, 0U +objptr, 0U +objsize1, 0U +objptrn, 0U +objsize2
		, 0U +bgmode
		);
	rendertext(pDC, dcMem, &rc, text);
	rc.left += tm.tmAveCharWidth * 35;
	//

	WORD bgobjptr = bg1objptr;
	WORD bgptr = bg1ptr;
	BYTE bgbpp = bgmode2bgx[bgmode & 7].bg1bpp;
	switch (tvt) {
		case tvtbg2: bgobjptr = bg2objptr, bgptr = bg2ptr, bgbpp = bgmode2bgx[bgmode & 7].bg2bpp; break;
		case tvtbg3: bgobjptr = bg3objptr, bgptr = bg3ptr, bgbpp = bgmode2bgx[bgmode & 7].bg3bpp; break;
		case tvtbg4: bgobjptr = bg4objptr, bgptr = bg4ptr, bgbpp = bgmode2bgx[bgmode & 7].bg4bpp; break;
	}

#if 0
	if (tvt != tvtsprite) {
		text.Empty();
		hexbin(text, bgobjptr, vram, 8);
		text += "\n";
		hexbin(text, bgptr, vram, 32);
		text += "\n";

		rendertext(pDC, dcMem, &rc, text);
		rc.left += tm.tmAveCharWidth * 50;
	}
#endif

#if 0
	// tile map format

	//  + 76543210
	// 0| ########
	// 1| YX?ppp##

	// ########## = tile #
	//        ppp = palette #
	//         ss = tile size
	//          X = flip X
	//          Y = flip Y

	if (tvt != tvtsprite) {
		text.Format("  x|  y| off|P|XY|     | \n"
					"---+---+----+-+--+-----+ \n");
		for (BYTE y = 0; y < 4; y++) {
			for (BYTE x = 0; x < 32; x++) {
				BYTE *ptr = &vram[bgptr +2U*(0U +x +32U*(y))];
				text.AppendFormat(
					"%3u|%3u|%4u|%X|%c%c|%02X %02X| \n"
					, 0U +x
					, 0U +y
					, 0U +((ptr[0] + ptr[1] * 256) & 0x03FF)
					, 0U +((ptr[1] >> 2) & 7)
					, (ptr[1] & 0x40) ? '*' : ' '
					, (ptr[1] & 0x80) ? '*' : ' '
					, 0U +ptr[0]
					, 0U +ptr[1]
					);
			}
		}

		rendertext(pDC, dcMem, &rc, text);
		rc.left += tm.tmAveCharWidth * 30;
	}
#endif

#if 1
	if (tvt != tvtsprite) {
		BYTE pix[64]; // 8x8 (8bpp)
		const BYTE nwx = 32;
		const BYTE nwy = 32;
		const BYTE nty = 1;
		const BYTE ntx = 1;

		BYTE offfac = 16;
		switch (bgbpp) {
			case 2: offfac = 4; break;
		}

		for (BYTE wy=0; wy<nwy; wy++) {
			for (BYTE wx=0; wx<nwx; wx++) {
				UINT index = wx + 32U*(wy);
				BYTE *ptr = &vram[0xFFFF & (bgptr +2*index)];
				BYTE offset = ((ptr[1] >> 2) & 7) * offfac;
				UINT tile = ((ptr[0] + ptr[1] * 256) & 0x03FF);
				bool flipx = (ptr[1] & 0x40) ? true : false;
				bool flipy = (ptr[1] & 0x80) ? true : false;

				BYTE sizeo = 0;

				BYTE maskxy = 0;
				switch (sizeo) {
					case 0: maskxy = 0x11; break;
					case 2: maskxy = 0x33; break;
				}

				for (BYTE ty=0; ty<nty; ty++) {
					for (BYTE tx=0; tx<ntx; tx++) {
						if (true
							&& 0 != (maskxy & (0x10 << tx))
							&& 0 != (maskxy & (0x01 << ty))
						) {
							switch (bgbpp) {
								case 4:
									SNESUtil::convert8x8_4_to_8(&vram[0xFFFF & (bgobjptr +32U*(tile))], pix);
									break;
								case 2:
									SNESUtil::convert8x8_2_to_8(&vram[0xFFFF & (bgobjptr +16U*(tile))], pix);
									break;
								default:
									FillMemory(pix, sizeof(pix), 0);
									break;
							}
						} else {
							FillMemory(pix, sizeof(pix), 0);
						}

						for (BYTE y=0; y<8; y++) {
							for (BYTE x=0; x<8; x++) {
								BYTE xx = flipx ? (7U-x) : x;
								BYTE yy = flipy ? (7U-y) : y;
								BYTE v = pix[yy * 8 + xx];
								bits[bcx * (bcy -1 -(y+8*(ty+nty*(wy)))) +(x+8*(tx+ntx*(wx)))] = offset + v;
							}
						}
					}
				}
			}
		}

		const UINT vcx = min(256, bi.bmiHeader.biWidth);
		const UINT vcy = min(256, bi.bmiHeader.biHeight);

		SetDIBitsToDevice(
			*pDC,
			rc.left,
			rc.top,
			vcx,
			vcy,
			0,
			0,
			0,
			vcy,
			bits,
			&bi,
			DIB_RGB_COLORS
			);
		pDC->ExcludeClipRect(
			rc.left,
			rc.top,
			rc.left +vcx,
			rc.top +vcy
			);
	}
#endif

	// OAM RAM. lower part (0-511 bytes)

	//  + 76543210
	// 0| xxxxxxxx
	// 1| yyyyyyyy
	// 2| ########
	// 3| YXRRppp#

	//   xxxxxxxx = x coord
	//   yyyyyyyy = y coord
	//  ######### = tile #
	//        ppp = palette #
	//         RR = priority
	//          X = flip X
	//          Y = flip Y
#if 1
	if (tvt == tvtsprite) {
		static const LPCTSTR tableobjsize[] = {
			" 8x8 ",
			" *1  ",
			"16x16",
			" *3  ",
		};
		text.Format("  i|  x|  y|off| P|R|size |XY| \n"
					"---+---+---+---+--+-+-----+--+ \n");
		for (int y = 0; y < 64; y++) {
			BYTE *ptr = &oamram[4 * y];
			text.AppendFormat(
				"%3u|%3u|%3u|%3u|%2u|%01X|%s|%c%c| \n"
				, 0U +y
				, 0U +ptr[0]
				, 0U +ptr[1]
				, 0U +((ptr[2] + ptr[3] * 256) & 0x01FF)
				, 0U +((ptr[3] >> 1) & 0x07)
				, 0U +((ptr[3] >> 4) & 0x03)
				, tableobjsize[((oamram[512 + y / 4] >> ((y % 4) * 2)) & 3)]
				, (ptr[3] & 0x40) ? '*' : ' '
				, (ptr[3] & 0x80) ? '*' : ' '
				);
		}

		rendertext(pDC, dcMem, &rc, text);
		rc.left += tm.tmAveCharWidth * 35;
	}
#endif
	//
	if (tvt == tvtsprite) {
		//
		BYTE pix[64]; // 8x8 (8bpp)
#if 1
		const BYTE nwx = 8;
		const BYTE nwy = 16;
		const BYTE nty = 2;
		const BYTE ntx = 2;

		for (BYTE wy=0; wy<nwy; wy++) {
			for (BYTE wx=0; wx<nwx; wx++) {
				BYTE wi = wx+nwx*(wy);
				BYTE *ptr = &oamram[4*wi];
				BYTE offset = 128 + ((ptr[3] >> 1) & 7) * 16;
				UINT tile = ((ptr[2] + ptr[3] * 256) & 0x01FF);
				bool flipx = (ptr[3] & 0x40) ? true : false;
				bool flipy = (ptr[3] & 0x80) ? true : false;

				BYTE sizeo = ((oamram[512 + wi / 4] >> ((wi % 4) * 2)) & 3);

				BYTE maskxy = 0;
				switch (sizeo) {
					case 0: maskxy = 0x11; break;
					case 2: maskxy = 0x33; break;
				}

				for (BYTE ty=0; ty<nty; ty++) {
					for (BYTE tx=0; tx<ntx; tx++) {

						if (true
							&& 0 != (maskxy & (0x10 << tx))
							&& 0 != (maskxy & (0x01 << ty))
						) {
							SNESUtil::convert8x8_4_to_8(&vram[0xFFFF & (objptr +32U*(tile +tx +16*ty))], pix);
						} else {
							FillMemory(pix, sizeof(pix), 0);
						}

						for (BYTE y=0; y<8; y++) {
							for (BYTE x=0; x<8; x++) {
								BYTE xx = flipx ? (7U-x) : x;
								BYTE yy = flipy ? (7U-y) : y;

								BYTE v = pix[yy * 8 + xx];
								bits[bcx * (bcy -1 -(y+8*(ty+nty*(wy)))) +(x+8*(tx+ntx*(wx)))] = offset + v;
							}
						}
					}
				}
			}
		}
#endif
		//

		const UINT vcx = min(128, bi.bmiHeader.biWidth);
		const UINT vcy = min(256, bi.bmiHeader.biHeight);

		SetDIBitsToDevice(
			*pDC,
			rc.left,
			rc.top,
			vcx,
			vcy,
			0,
			0,
			0,
			vcy,
			bits,
			&bi,
			DIB_RGB_COLORS
			);
		pDC->ExcludeClipRect(
			rc.left,
			rc.top,
			rc.left +vcx,
			rc.top +vcy
			);
	}

	//
	dcMem.RestoreDC(-1);
	dcMem.DeleteDC();

	pDC->FillSolidRect(rc0, RGB(0, 0, 88));
}

void CTailerVw::OnDraw(CDC* pDC)
{
	ASSERT(_HEAPOK == _heapchk());

	if (!IsWindowVisible()) return;

	pDC->SaveDC();

	if (tvt == tvtsprite) {
		renderSprite(pDC);
	}
	else {
		renderSprite(pDC);
	}

	pDC->RestoreDC(-1);
}

BOOL CTailerVw::OnEraseBkgnd(CDC* pDC)
{
	return true;
}

inline void colorconvert(RGBQUAD &rgb, COLORREF clr)
{
	rgb.rgbRed   = GetRValue(clr);
	rgb.rgbGreen = GetGValue(clr);
	rgb.rgbBlue  = GetBValue(clr);
	rgb.rgbReserved = 0;
}

int CTailerVw::OnCreate(LPCREATESTRUCT lpCreateStruct)
{
	if (CView::OnCreate(lpCreateStruct) == -1)
		return -1;

	bmoffscr.DeleteObject();
	pvoffscr = NULL;
	tvt = tvtsprite;

	ZeroMemory(bioffscrbuff, sizeof(bioffscrbuff));
	BITMAPINFO &bi = (BITMAPINFO &)bioffscrbuff[0];
	bi.bmiHeader.biSize = sizeof(BITMAPINFOHEADER);
	bi.bmiHeader.biWidth = 512;
	bi.bmiHeader.biHeight = 1024;
	bi.bmiHeader.biPlanes = 1;
	bi.bmiHeader.biBitCount = 1;
	colorconvert(bi.bmiColors[0], RGB(0,0,88));
	colorconvert(bi.bmiColors[1], RGB(255,255,255));

	CCompatDC dc(this);
	HBITMAP hbm = CreateDIBSection(
		dc,
		&bi,
		DIB_RGB_COLORS,
		&pvoffscr,
		NULL,
		0
		);
	if (hbm == NULL)
		return -1;
	bmoffscr.Attach(hbm);

	SetTimer(0x0100, 251, NULL);

	return 0;
}

BOOL CTailerVw::PreCreateWindow(CREATESTRUCT& cs)
{
	if (!CView::PreCreateWindow(cs)) return false;

	cs.dwExStyle &= ~WS_EX_CLIENTEDGE;
	return true;
}

void CTailerVw::OnTimer(UINT nIDEvent)
{
	if (nIDEvent == 0x0100)
		Invalidate(false);

	CView::OnTimer(nIDEvent);
}
