
#include "StdAfx.h"
#include "resource.h"
#include "DebFrame.h"
#include "DebApp.h"
#include "fprintf.h"
#include "SNESop.h"
#include "CustomFrame.h"
#include "ScriptServer.h"
#include "fprintfi.h"
#include "SNESop.h"
#include "AstralFrame.h"
#include "IDEFrame.h"

#define _DEBUG_SUB_ENTER			0 // +>  sub-routine enter
#define _DEBUG_SUB_LEAVE			0 // <+  sub-routine leave
#define _DEBUG_RET_PRE				0 // -%  pre sub-routine return
#define _DEBUG_RET_POST				0 // %-  post sub-routine return
#define _DEBUG_CALLSTACK_VIOLATION	0 // --  return addr on stack violated due to increment [xs]
#define _DEBUG_CALLSTACK_MISMATCH	0 // !=  [xs] points mismatch addr. [xs] when enter is different from [xs] when leave
#define _DEBUG_ADD_STACKSET			0 // <00/D3E2   06/D3F1 06/D420   00/D3E6> <1FE5 1FE5   1          4>

// extern
extern "C" DWORD fprintf_pc_offset;
extern "C" BYTE xpb;
extern "C" BYTE SA1xpb;
extern "C" BYTE fprintf_status;
extern "C" BYTE fprintfc_init_call;
extern "C" BYTE fprintf_switch;
extern "C" DWORD fprintf_apu_pc;
extern "C" BYTE spcP;
extern "C" BYTE spcRam[];
extern "C" DWORD fprintf_clear_offset;
extern "C" DWORD fprintf_clear_size;

extern "C" DWORD fprintf_sa1_pc;
extern "C" BYTE fprintf_sa1_switch;
extern "C" BYTE fprintf_sa1_status;

// var
DWORD fprintfc_new_offset;
DWORD fprintfc_old_offset;
DWORD fprintfc_old_exec;
DWORD fprintfc_apuold;
DWORD fprintfc_apunew;
DWORD fprintfc_apuold_exec;
DWORD fprintfc_sa1old;
DWORD fprintfc_sa1new;
DWORD fprintfc_sa1old_exec;
WalkAscMap walkMapAsc; // foot-print ascend order
WalkAscMap walkMapAPU;
WalkAscMap walkMapSA1;
ScriptoVec scriptoVec;
CScriptoServer scriptoServer;
CodeBreak breakCode[MAX_CODEBREAK];
BYTE fprintfc_init_call = 0;
DWORD refPostProcess, refSingleStep;
CIDEFrame frameide;

// func

namespace {

};

extern "C" void fprintf_init_service_c(void)
{
	fprintfc_new_offset = fprintfc_old_offset = -1;
	fprintfc_apuold = fprintfc_apunew = -1;
	fprintfc_sa1old = fprintfc_sa1new = -1;
	fprintfc_old_exec = fprintfc_apuold_exec = fprintfc_sa1old_exec = 0;
	fprintf_switch = 0;
	fprintf_apu_pc = 0;
	refPostProcess = 0;
	refSingleStep = 0;

	static_cast<CDebApp *>(AfxGetApp())->OnOurDebug(1, 0);

	walkMapAsc.clear();
	walkMapAPU.clear();
	walkMapSA1.clear();
//	frame.vw.ResetContents();
//	framec.vw.Reset();
//	frameg.vw.Reset();

	ZeroMemory(breakCode, sizeof(breakCode));

	scriptoServer.Sync();
}

extern "C" void fprintf_intAPU_service_c(void)
{
	static const DWORD masktable[] = {
		0x00000000,
		0x000000FF,
		0x0000FFFF,
		0x00FFFFFF,
	};
	fprintfc_apunew = fprintf_apu_pc;

	WalkAsc asc(fprintfc_apuold, fprintfc_apunew);
	WalkRec &r = walkMapAPU[asc];
	DWORD exec = *(DWORD *)&spcRam[fprintfc_apunew];
	if (r.occur == 0) {
		r.exec = exec;
		r.execo = fprintfc_apuold_exec;
	}
	r.occur++;
	r.status = spcP;

	fprintfc_apuold_exec = exec;
	fprintfc_apuold = fprintfc_apunew;
}

extern "C" void fprintf_intSA1_service_c(void)
{
	static DWORD index, more;

	fprintfc_sa1new = fprintf_sa1_pc | (SA1xpb << 16);
	// ---
	more = (fprintf_sa1_switch) ? 0x80000000 : 0;
	fprintf_sa1_switch = 0;

	WalkAsc asc(fprintfc_sa1old, fprintfc_sa1new | more);
	WalkRec &r = walkMapSA1[asc];

	fprintfi_addr = fprintfc_sa1new;
	fprintfi_read_mem32();

	if (r.occur == 0) {
		r.exec = fprintfi_read;
		r.execo = fprintfc_sa1old_exec;
	}
	r.occur++;
	r.status = fprintf_sa1_status;
	// ---
	fprintfc_sa1old_exec = fprintfi_read;
	fprintfc_sa1old = fprintfc_sa1new;
}

extern "C" void fprintf_interrupt_service_c(void)
{
	static DWORD index, more;

	if (fprintfc_init_call != 0) {
		fprintfc_init_call = 0;
		fprintf_init_service_c();
	}

	fprintfc_new_offset = fprintf_pc_offset | (xpb << 16);
	// ---
	more = (fprintf_switch) ? 0x80000000 : 0;
	fprintf_switch = 0;

	WalkAsc asc(fprintfc_old_offset, fprintfc_new_offset | more);
	WalkRec &r = walkMapAsc[asc];

	fprintfi_addr = fprintfc_new_offset;
	fprintfi_read_mem32();

	if (r.occur == 0) {
		r.exec = fprintfi_read;
		r.execo = fprintfc_old_exec;
	}
	r.occur++;
	r.status = fprintf_status;
	// ---
	const DWORD addrNew = fprintfc_new_offset;
	for (index = 0; index < MAX_CODEBREAK; index++) {
		if (breakCode[index].nRefs == 0 || (refSingleStep == 0 && breakCode[index].addr != addrNew)) continue;

		scriptoServer.CodeBreakNow(addrNew);
	}

	if (refPostProcess != 0 && refSingleStep == 0) {
		const DWORD addrOld = fprintfc_old_offset;
		for (index = 0; index < MAX_CODEBREAK; index++) {
			if (breakCode[index].nRefs == 0 || (refSingleStep == 0 && breakCode[index].addr != addrOld)) continue;

			scriptoServer.CodeBreakPostProcNow(addrOld, addrNew);
		}
	}
	// ---
	fprintfc_old_exec = fprintfi_read;
	fprintfc_old_offset = fprintfc_new_offset;
}

extern "C" void fprintf_init_instance_c(void);
extern "C" void fprintf_exit_instance_c(void);

extern "C" void fprintf_init_instance_c(void)
{
	atexit(fprintf_exit_instance_c);
}

extern "C" void fprintf_exit_instance_c(void)
{
	scriptoServer.Close();
	frameide.DestroyWindow();
}

extern "C" void fprintf_display_c(void)
{
	PostThreadMessage(GetCurrentThreadId(), PM_OUR_DEBUG, 0, 0);
}

extern "C" void fprintf_clear_spc_c(void)
{
	return;
//	DWORD i = fprintf_clear_offset;
//	DWORD n = fprintf_clear_size;
//	do {
//		for (char x = 0; x < 2; x++) {
//			WalkAscMap::iterator
//				iterPos = walkMapAPU.lower_bound(WalkAsc(i,  0)),
//				iterEnd = walkMapAPU.upper_bound(WalkAsc(i, -1));
//			walkMapAPU.erase(iterPos, iterEnd);
//			i++;
//		}
//		n--;
//	} while (n != 0);
}

extern "C" HWND fprintf_get_frame_window(void)
{
	fprintf_init_service_c();

	return frameide.wndMonitor;
}

extern "C" HWND fprintf_get_toplevel_window(void)
{
	return frameide;
}
