
#ifndef _FPRINTF_H_
#define _FPRINTF_H_

// typedef
struct WalkAsc {
	DWORD oldPos, newPos;

	inline WalkAsc() { }
	inline WalkAsc(DWORD oldPos, DWORD newPos): oldPos(oldPos), newPos(newPos) { }

	inline int CompareTo(const WalkAsc &r) const
	{
		if (oldPos < r.oldPos) return -1;
		if (oldPos > r.oldPos) return +1;
		if (newPos < r.newPos) return -1;
		if (newPos > r.newPos) return +1;
		return 0;
	}
	bool operator ==(const WalkAsc &r) const { return oldPos == r.oldPos && newPos == r.newPos; }
	bool operator <(const WalkAsc &r) const { return CompareTo(r) < 0; }
	bool operator >(const WalkAsc &r) const { return CompareTo(r) > 0; }
};
struct WalkRec {
	DWORD occur;
	BYTE status;
	DWORD exec, execo;

	inline WalkRec() { occur = 0; status = 0; }
};
typedef std::map<WalkAsc, WalkRec> WalkAscMap;

struct Scripto {
	CString strEngine, strFile;
	bool fDisabled;
};
typedef std::vector<Scripto> ScriptoVec;

#define MAX_CODEBREAK 10U

struct CodeBreak {
	DWORD addr;
	DWORD nRefs;
};
extern CodeBreak breakCode[];

#include "ScriptServer.h"

// extern
extern WalkAscMap walkMapAsc; // foot-print ascend order
extern "C" BYTE *romdata;
extern ScriptoVec scriptoVec;
extern "C" BYTE *fprintf_infoloc;
extern CScriptoServer scriptoServer;
extern DWORD refPostProcess, refSingleStep;
extern DWORD fprintfc_old_offset, fprintfc_new_offset;
extern WalkAscMap walkMapAPU;
extern WalkAscMap walkMapSA1;

#endif // _FPRINTF_H_
