// test.js writte by kentaro-k.21
// test script to show some bits of running dungeon master.

// run here to perform script's initialization. run once.

main();

var msgob;

function main() {
	external.Message("initialization\n" + "test1\n" + "test2\n" + "test3\n", "test", 1);
	external.Message("CasetteName \""+ external.CasetteName +"\"", "test", 1);
	//external.Message(external.sprintf("%u + %u = %u", new Array(11, 22, 33)), "test", 1);

	var casetteName = external.CasetteName;

	if (casetteName != "DUNGEON MASTER") {
		external.Message("NOT A 'DUNGEON MASTER'", "test", 2);
		return;
	}

	external.AddCodeBreak(0x018000);
	//external.AddCodeBreak(0x009C89);
	//external.AddCodeBreak(0x048000);
	external.AddCodeBreak(0x03A515);
	external.AddCodeBreak(0x029299); // JP ver
	external.AddCodeBreak(0x0292E1); // US ver
	external.AddCodeBreak(0x048812);
	external.AddCodeBreak(0x048A9A);
	//external.AddCodeBreak(0x0486DD);
	external.AddCodeBreak(0x0485D2);
	external.AddCodeBreak(0x048694);
	external.AddCodeBreak(0x03A2DE);
	external.AddCodeBreak(0x03A284);
	
	//external.EnablePostProcess();
	//external.EnableSingleStep();
}

	// 03/C530 ... draw D1Wall
	// 03/C0D6 ... draw D1Lwall

function OnCodeBreakPostProcess(priorAddr, currentAddr) {
	external.Message(external.sprintf("pp (%#08X) >>> %#08X", new Array(priorAddr, currentAddr)), "test", 1);
}

function OnCodeBreak(addr) {
	var testFileName = ".\\test.7E0000-7F0000.bin";

	switch (addr) {
	case 0x018000: // Generic raw data indirect extractor
		external.Message(external.sprintf("Extract #%3u [%02X:%04X] (%s)", 
			new Array(
				external.xa
				, external.ReadMem8(0x2E)
				, external.ReadMem16(0x2F)
				, Get_RawDataName(external.xa))
				)
			, "test", 1
			);
		break;
	case 0x009C89: // Decompressor 0x02
		external.Message("T02", "test", 1);
		break;
	case 0x048000: // Decompressor 0x03
		external.Message("T03", "test", 1);
		break;
	case 0x03A515:
		external.Message("Draw wall ornate #" + external.xa, "test", 1);
		break;
	case 0x029299: // JP ver
	case 0x0292E1: // US ver
		// DUNGEON.DAT has been read

//		external.Message("DUNGEON.DAT has been read", "test", 1);

		external.Message("Capture memory test start", "test", 1);
		external.CaptureMemoryToVar(0x7E0000, 0x7FFFFF);
//		external.CaptureMemoryToFile(0x7E0000, 0x7FFFFF, testFileName);
//		external.Message("Capture memory test end ("+ testFileName +")", "test", 1);
		break;
	case 0x048A9A: // post DSP1 t2 c05 user
		var cx = 0x54; // (external.ReadMem16(0x01DA) + 1) & 0xFFFE;
		var cy = 0x80; // (external.ReadMem16(0x01DC));
		var addrfrom = 0x7E2000; // 0x7E0000 | external.ReadMem16(0x01EF);
		var addrto = (addrfrom + cx * cy);
		var memory = external.CaptureMemoryToVar(addrfrom & 0xFFFFFF, addrto & 0xFFFFFF);

		msgob.AddString("after composite:");
		msgob.AddBR();
		msgob.Add4bppImage(memory, 0, cx * 2, cy);
		msgob.AddBR();
		break;
	case 0x048812: // DSP1 t2 c05 user
		msgob = external.Message(external.sprintf("%sDSP2 c05 <x=%04X y=%04X cx=%04X cy=%04X><dst=7E:%04X src=0A:%04X>", 
			new Array(""
				, external.ReadMem16(0x01D4) // x?
				, external.ReadMem16(0x01D0) // y?
				, external.ReadMem16(0x01DA) // width?
				, external.ReadMem16(0x01DC) // height?
				, external.ReadMem16(0x01EF) & 0xFFFF // ?
				, external.ReadMem16(0x01EB) & 0xFFFF // ?
				, 0
			)), "test", 1
			);

		break;
	case 0x0486DD: // DSP1 t2 c09 user
		external.Message(external.sprintf("%sDSP2 c09 <x=%04X y=%04X r=%04X>", 
			new Array(""
				, external.ReadMem16(0x01F9) // x?
				, external.ReadMem16(0x01FB) // y?
				, external.xa
				, 0
			)), "test", 1
			);
		break;
	case 0x0485D2: // sprite draw procedure top?
		external.Message(external.sprintf("%s0485D2(%04X,%04X,%04X,%04X,%04X,%04X,%04X,%04X,%04X,%04X,%04X) R:%06X ->",
			new Array(""
				, external.ReadMem16(external.xs +1 +3 + 0) & 0xFFFF
				, external.ReadMem16(external.xs +1 +3 + 2) & 0xFFFF
				, external.ReadMem16(external.xs +1 +3 + 4) & 0xFFFF
				, external.ReadMem16(external.xs +1 +3 + 6) & 0xFFFF
				, external.ReadMem16(external.xs +1 +3 + 8) & 0xFFFF
				, external.ReadMem16(external.xs +1 +3 +10) & 0xFFFF
				, external.ReadMem16(external.xs +1 +3 +12) & 0xFFFF
				, external.ReadMem16(external.xs +1 +3 +14) & 0xFFFF
				, external.ReadMem16(external.xs +1 +3 +16) & 0xFFFF
				, external.ReadMem16(external.xs +1 +3 +18) & 0xFFFF
				, external.ReadMem16(external.xs +1 +3 +20) & 0xFFFF
				, external.ReadMem32(external.xs +1) & 0xFFFFFF
			)), "test", 1);
		break;
	case 0x048694: // sprite draw inside?
		external.Message(external.sprintf("%s- 558rect %02X:%04X", 
			new Array(""
				, external.ReadMem8(0x01F5) & 0xFF
				, external.ReadMem16(0x01F3) & 0xFFFF
			)), "test", 1
			);
		break;
	case 0x03A2DE: // pre sprite draw begin
		external.Message(external.sprintf("%s03A2DE(%04X,%04X,%04X,%04X) R:%06X ->",
			new Array(""
				, external.ReadMem16(external.xs +1 +3 +0) & 0xFFFF
				, external.ReadMem16(external.xs +1 +3 +2) & 0xFFFF
				, external.ReadMem16(external.xs +1 +3 +4) & 0xFFFF
				, external.ReadMem16(external.xs +1 +3 +6) & 0xFFFF
				, external.ReadMem32(external.xs +1) & 0xFFFFFF
			)), "test", 1);
		break;
	case 0x03A284: // prespritedraw2? begin
		external.Message(external.sprintf("%s03A284(%04X,%04X,%04X,%04X) R:%06X ->",
			new Array(""
				, external.ReadMem16(external.xs +1 +3 +0) & 0xFFFF
				, external.ReadMem16(external.xs +1 +3 +2) & 0xFFFF
				, external.ReadMem16(external.xs +1 +3 +4) & 0xFFFF
				, external.ReadMem16(external.xs +1 +3 +6) & 0xFFFF
				, external.ReadMem32(external.xs +1) & 0xFFFFFF
			)), "test", 1);
		break;
	}
}

function Get_RawDataName(x) {
	switch (x) {
		case 0: return "Dungeon Graphics - Floor";
		case 1: return "Dungeon Graphics - Ceiling";
		case 2: return "Dungeon Graphics - Door Right Frame (Front 1)";
		case 3: return "Dungeon Graphics - Door Left or Right Frame (Front 1)";
		case 4: return "Dungeon Graphics - Door Left Frame (Front 1)";
		case 5: return "Dungeon Graphics - Door Left Frame (Front 2)";
		case 6: return "Dungeon Graphics - Door Left Frame (Front 3)";
		case 7: return "Dungeon Graphics - Door Left Frame (Left Side 3)";
		case 8: return "Dungeon Graphics - Door Top Frame (Front 1)";
		case 9: return "Dungeon Graphics - Door Top Frame (Front 2)";
		case 10: return "Dungeon Graphics - Wall (Right Side 0)";
		case 11: return "Dungeon Graphics - Wall (Left Side 0)";
		case 12: return "Dungeon Graphics - Wall (Front and Sides 1)";
		case 13: return "Dungeon Graphics - Wall (Front and Sides 2)";
		case 14: return "Dungeon Graphics - Wall (Front and Sides 3)";
		case 15: return "Dungeon Graphics - Wall (Far Left Side 3)";
		case 16: return "Dungeon Graphics - Wall (Far Right Side 3)";
		case 17: return "Dungeon Graphics - Stairs Up (Front 3 Left)";
		case 18: return "Dungeon Graphics - Stairs Up (Front 3)";
		case 19: return "Dungeon Graphics - Stairs Up (Front 2 Left)";
		case 20: return "Dungeon Graphics - Stairs Up (Front 2)";
		case 21: return "Dungeon Graphics - Stairs Up (Front 1 Left)";
		case 22: return "Dungeon Graphics - Stairs Up (Front 1)";
		case 23: return "Dungeon Graphics - Stairs Up (Front 0)";
		case 24: return "Dungeon Graphics - Stairs Down (Front 3 Left)";
		case 25: return "Dungeon Graphics - Stairs Down (Front 3)";
		case 26: return "Dungeon Graphics - Stairs Down (Front 2 Left)";
		case 27: return "Dungeon Graphics - Stairs Down (Front 2)";
		case 28: return "Dungeon Graphics - Stairs Down (Front 1 Left)";
		case 29: return "Dungeon Graphics - Stairs Down (Front 1)";
		case 30: return "Dungeon Graphics - Stairs Down (Front 0)";
		case 31: return "Dungeon Graphics - Stairs (Side 3 Left)";
		case 32: return "Dungeon Graphics - Stairs Up (Side 2 Left)";
		case 33: return "Dungeon Graphics - Stairs Down (Side 2 Left)";
		case 34: return "Dungeon Graphics - Stairs (Side 1)";
		case 35: return "Door Graphics 0 (Front 3) - Porticullis";
		case 36: return "Door Graphics 0 (Front 2) - Porticullis";
		case 37: return "Door Graphics 0 (Front 1) - Porticullis";
		case 38: return "Door Graphics 1 (Front 3) - Wooden Door";
		case 39: return "Door Graphics 1 (Front 2) - Wooden Door";
		case 40: return "Door Graphics 1 (Front 1) - Wooden Door";
		case 41: return "Door Graphics 2 (Front 3) - Iron Door";
		case 42: return "Door Graphics 2 (Front 2) - Iron Door";
		case 43: return "Door Graphics 2 (Front 1) - Iron Door";
		case 44: return "Door Graphics 3 (Front 3) - Ra Door";
		case 45: return "Door Graphics 3 (Front 2) - Ra Door";
		case 46: return "Door Graphics 3 (Front 1) - Ra Door";
		case 47: return "Font";
		case 48: return "Wall Ornate 00 (Left Side) - Wall Inscription Frame";
		case 49: return "Wall Ornate 00 (Front) - Wall Inscription Frame";
		case 50: return "Wall Ornate 01 (Left Side) - Square Alcove";
		case 51: return "Wall Ornate 01 (Front) - Square Alcove";
		case 52: return "Wall Ornate 02 (Left Side) - Vi Altar";
		case 53: return "Wall Ornate 02 (Front) - Vi Altar";
		case 54: return "Wall Ornate 03 (Left Side) - Arched Alcove";
		case 55: return "Wall Ornate 03 (Front) - Arched Alcove";
		case 56: return "Wall Ornate 04 (Left Side) - Hook";
		case 57: return "Wall Ornate 04 (Front) - Hook";
		case 58: return "Wall Ornate 05 (Left Side) - Iron Lock";
		case 59: return "Wall Ornate 05 (Front) - Iron Lock";
		case 60: return "Wall Ornate 06 (Left Side) - Wood Ring";
		case 61: return "Wall Ornate 06 (Front) - Wood Ring";
		case 62: return "Wall Ornate 07 (Left Side) - Small Switch";
		case 63: return "Wall Ornate 07 (Front) - Small Switch";
		case 64: return "Wall Ornate 08 (Left Side) - Dent 1";
		case 65: return "Wall Ornate 08 (Front) - Dent 1";
		case 66: return "Wall Ornate 09 (Left Side) - Dent 2";
		case 67: return "Wall Ornate 09 (Front) - Dent 2";
		case 68: return "Wall Ornate 10 (Left Side) - Iron Ring";
		case 69: return "Wall Ornate 10 (Front) - Iron Ring";
		case 70: return "Wall Ornate 11 (Left Side) - Crack";
		case 71: return "Wall Ornate 11 (Front) - Crack";
		case 72: return "Wall Ornate 12 (Left Side) - Slime Outlet";
		case 73: return "Wall Ornate 12 (Front) - Slime Outlet";
		case 74: return "Wall Ornate 13 (Left Side) - Dent 3";
		case 75: return "Wall Ornate 13 (Front) - Dent 3";
		case 76: return "Wall Ornate 14 (Left Side) - Tiny Switch";
		case 77: return "Wall Ornate 14 (Front) - Tiny Switch";
		case 78: return "Wall Ornate 15 (Left Side) - Green Switch Out";
		case 79: return "Wall Ornate 15 (Front) - Green Switch Out";
		case 80: return "Wall Ornate 16 (Left Side) - Blue Switch Out";
		case 81: return "Wall Ornate 16 (Front) - Blue Switch Out";
		case 82: return "Wall Ornate 17 (Left Side) - Coin Slot";
		case 83: return "Wall Ornate 17 (Front) - Coin Slot";
		case 84: return "Wall Ornate 18 (Left Side) - Double Iron Lock";
		case 85: return "Wall Ornate 18 (Front) - Double Iron Lock";
		case 86: return "Wall Ornate 19 (Left Side) - Square Lock";
		case 87: return "Wall Ornate 19 (Front) - Square Lock";
		case 88: return "Wall Ornate 20 (Left Side) - Winged Lock";
		case 89: return "Wall Ornate 20 (Front) - Winged Lock";
		case 90: return "Wall Ornate 21 (Left Side) - Onyx Lock";
		case 91: return "Wall Ornate 21 (Front) - Onyx Lock";
		case 92: return "Wall Ornate 22 (Left Side) - Stone Lock";
		case 93: return "Wall Ornate 22 (Front) - Stone Lock";
		case 94: return "Wall Ornate 23 (Left Side) - Cross Lock";
		case 95: return "Wall Ornate 23 (Front) - Cross Lock";
		case 96: return "Wall Ornate 24 (Left Side) - Topaz Lock";
		case 97: return "Wall Ornate 24 (Front) - Topaz Lock";
		case 98: return "Wall Ornate 25 (Left Side) - Skeleton Lock";
		case 99: return "Wall Ornate 25 (Front) - Skeleton Lock";
		case 100: return "Wall Ornate 26 (Left Side) - Gold Lock";
		case 101: return "Wall Ornate 26 (Front) - Gold Lock";
		case 102: return "Wall Ornate 27 (Left Side) - Tourquoise Lock";
		case 103: return "Wall Ornate 27 (Front) - Tourquoise Lock";
		case 104: return "Wall Ornate 28 (Left Side) - Emerald Lock";
		case 105: return "Wall Ornate 28 (Front) - Emerald Lock";
		case 106: return "Wall Ornate 29 (Left Side) - Ruby Lock";
		case 107: return "Wall Ornate 29 (Front) - Ruby Lock";
		case 108: return "Wall Ornate 30 (Left Side) - Ra Lock";
		case 109: return "Wall Ornate 30 (Front) - Ra Lock";
		case 110: return "Wall Ornate 31 (Left Side) - Master Lock";
		case 111: return "Wall Ornate 31 (Front) - Master Lock";
		case 112: return "Wall Ornate 32 (Left Side) - Gem Hole";
		case 113: return "Wall Ornate 32 (Front) - Gem Hole";
		case 114: return "Wall Ornate 33 (Left Side) - Slime";
		case 115: return "Wall Ornate 33 (Front) - Slime";
		case 116: return "Wall Ornate 34 (Left Side) - Grate";
		case 117: return "Wall Ornate 34 (Front) - Grate";
		case 118: return "Wall Ornate 35 (Left Side) - Fountain";
		case 119: return "Wall Ornate 35 (Front) - Fountain";
		case 120: return "Wall Ornate 36 (Left Side) - Manacles";
		case 121: return "Wall Ornate 36 (Front) - Manacles";
		case 122: return "Wall Ornate 37 (Left Side) - Ghoul's Head";
		case 123: return "Wall Ornate 37 (Front) - Ghoul's Head";
		case 124: return "Wall Ornate 38 (Left Side) - Empty Torch Holder";
		case 125: return "Wall Ornate 38 (Front) - Empty Torch Holder";
		case 126: return "Wall Ornate 39 (Left Side) - Scratches";
		case 127: return "Wall Ornate 39 (Front) - Scratches";
		case 128: return "Wall Ornate 40 (Left Side) - Poison Holes";
		case 129: return "Wall Ornate 40 (Front) - Poison Holes";
		case 130: return "Wall Ornate 41 (Left Side) - Fireball Holes";
		case 131: return "Wall Ornate 41 (Front) - Fireball Holes";
		case 132: return "Wall Ornate 42 (Left Side) - Dagger Holes";
		case 133: return "Wall Ornate 42 (Front) - Dagger Holes";
		case 134: return "Wall Ornate 43 (Left Side) - Champion Mirror";
		case 135: return "Wall Ornate 43 (Front) - Champion Mirror";
		case 136: return "Wall Ornate 44 (Left Side) - Lever Up";
		case 137: return "Wall Ornate 44 (Front) - Lever Up";
		case 138: return "Wall Ornate 45 (Left Side) - Lever Down";
		case 139: return "Wall Ornate 45 (Front) - Lever Down";
		case 140: return "Wall Ornate 46 (Left Side) - Full Torch Holder";
		case 141: return "Wall Ornate 46 (Front) - Full Torch Holder";
		case 142: return "Wall Ornate 47 (Left Side) - Red Switch Out";
		case 143: return "Wall Ornate 47 (Front) - Red Switch Out";
		case 144: return "Wall Ornate 48 (Left Side) - Eye Switch";
		case 145: return "Wall Ornate 48 (Front) - Eye Switch";
		case 146: return "Wall Ornate 49 (Left Side) - Big Switch Out";
		case 147: return "Wall Ornate 49 (Front) - Big Switch Out";
		case 148: return "Wall Ornate 50 (Left Side) - Crack Switch Out";
		case 149: return "Wall Ornate 50 (Front) - Crack Switch Out";
		case 150: return "Wall Ornate 51 (Left Side) - Green Switch In";
		case 151: return "Wall Ornate 51 (Front) - Green Switch In";
		case 152: return "Wall Ornate 52 (Left Side) - Blue Switch In";
		case 153: return "Wall Ornate 52 (Front) - Blue Switch In";
		case 154: return "Wall Ornate 53 (Left Side) - Red Switch In";
		case 155: return "Wall Ornate 53 (Front) - Red Switch In";
		case 156: return "Wall Ornate 54 (Left Side) - Big Switch In";
		case 157: return "Wall Ornate 54 (Front) - Big Switch In";
		case 158: return "Wall Ornate 55 (Left Side) - Crack Switch In";
		case 159: return "Wall Ornate 55 (Front) - Crack Switch In";
		case 160: return "Wall Ornate 56 (Left Side) - Amalgam (Encased Gem)";
		case 161: return "Wall Ornate 56 (Front) - Amalgam (Encased Gem)";
		case 162: return "Wall Ornate 57 (Left Side) - Amalgam (Free Gem)";
		case 163: return "Wall Ornate 57 (Front) - Amalgam (Free Gem)";
		case 164: return "Wall Ornate 58 (Left Side) - Amalgam (Without Gem)";
		case 165: return "Wall Ornate 58 (Front) - Amalgam (Without Gem)";
		case 166: return "Wall Ornate 59 (Left Side) - Lord Order (Outside)";
		case 167: return "Wall Ornate 59 (Front) - Lord Order (Outside)";
		case 168: return "Floor ornate 00 (Left Side 3) - Footprints";
		case 169: return "Floor ornate 00 (Front 3) - Footprints";
		case 170: return "Floor ornate 00 (Left Side 2) - Footprints";
		case 171: return "Floor ornate 00 (Front 2) - Footprints";
		case 172: return "Floor ornate 00 (Left Side 1) - Footprints";
		case 173: return "Floor ornate 00 (Front 1) - Footprints";
		case 174: return "Floor ornate 01 (Left Side 3) - Square Grate";
		case 175: return "Floor ornate 01 (Front 3) - Square Grate";
		case 176: return "Floor ornate 01 (Left Side 2) - Square Grate";
		case 177: return "Floor ornate 01 (Front 2) - Square Grate";
		case 178: return "Floor ornate 01 (Left Side 1) - Square Grate";
		case 179: return "Floor ornate 01 (Front 1) - Square Grate";
		case 180: return "Floor ornate 02 (Left Side 3) - Square Pressure Pad";
		case 181: return "Floor ornate 02 (Front 3) - Square Pressure Pad";
		case 182: return "Floor ornate 02 (Left Side 2) - Square Pressure Pad";
		case 183: return "Floor ornate 02 (Front 2) - Square Pressure Pad";
		case 184: return "Floor ornate 02 (Left Side 1) - Square Pressure Pad";
		case 185: return "Floor ornate 02 (Front 1) - Square Pressure Pad";
		case 186: return "Floor ornate 03 (Left Side 3) - Moss";
		case 187: return "Floor ornate 03 (Front 3) - Moss";
		case 188: return "Floor ornate 03 (Left Side 2) - Moss";
		case 189: return "Floor ornate 03 (Front 2) - Moss";
		case 190: return "Floor ornate 03 (Left Side 1) - Moss";
		case 191: return "Floor ornate 03 (Front 1) - Moss";
		case 192: return "Floor ornate 04 (Left Side 3) - Round Grate";
		case 193: return "Floor ornate 04 (Front 3) - Round Grate";
		case 194: return "Floor ornate 04 (Left Side 2) - Round Grate";
		case 195: return "Floor ornate 04 (Front 2) - Round Grate";
		case 196: return "Floor ornate 04 (Left Side 1) - Round Grate";
		case 197: return "Floor ornate 04 (Front 1) - Round Grate";
		case 198: return "Floor ornate 05 (Left Side 3) - Round Pressure Plate";
		case 199: return "Floor ornate 05 (Front 3) - Round Pressure Plate";
		case 200: return "Floor ornate 05 (Left Side 2) - Round Pressure Plate";
		case 201: return "Floor ornate 05 (Front 2) - Round Pressure Plate";
		case 202: return "Floor ornate 05 (Left Side 1) - Round Pressure Plate";
		case 203: return "Floor ornate 05 (Front 1) - Round Pressure Plate";
		case 204: return "Floor ornate 06 (Left Side 3) - Black Flame Pit";
		case 205: return "Floor ornate 06 (Front 3) - Black Flame Pit";
		case 206: return "Floor ornate 06 (Left Side 2) - Black Flame Pit";
		case 207: return "Floor ornate 06 (Front 2) - Black Flame Pit";
		case 208: return "Floor ornate 06 (Left Side 1) - Black Flame Pit";
		case 209: return "Floor ornate 06 (Front 1) - Black Flame Pit";
		case 210: return "Floor ornate 07 (Left Side 3) - Crack";
		case 211: return "Floor ornate 07 (Front 3) - Crack";
		case 212: return "Floor ornate 07 (Left Side 2) - Crack";
		case 213: return "Floor ornate 07 (Front 2) - Crack";
		case 214: return "Floor ornate 07 (Left Side 1) - Crack";
		case 215: return "Floor ornate 07 (Front 1) - Crack";
		case 216: return "Floor ornate 08 (Left Side 3) - Tiny Pressure Pad";
		case 217: return "Floor ornate 08 (Front 3) - Tiny Pressure Pad";
		case 218: return "Floor ornate 08 (Front 2) - Tiny Pressure Pad";
		case 219: return "Floor ornate 08 (Left Side 2) - Tiny Pressure Pad";
		case 220: return "Floor ornate 08 (Front 1) - Tiny Pressure Pad";
		case 221: return "Floor ornate 08 (Left Side 1) - Tiny Pressure Pad";
		case 222: return "Floor ornate 09 (Left Side 3) - Puddle";
		case 223: return "Floor ornate 09 (Front 3) - Puddle";
		case 224: return "Floor ornate 09 (Left Side 2) - Puddle";
		case 225: return "Floor ornate 09 (Front 2) - Puddle";
		case 226: return "Floor ornate 09 (Left Side 1) - Puddle";
		case 227: return "Floor ornate 09 (Front 1) - Puddle";
		case 228: return "Door Mask 0 - Bashed Door";
		case 229: return "Door Mask 1 - 'See Through Walls' Spell";
		case 230: return "Door Ornate 00 - Square Grid";
		case 231: return "Door Ornate 01 - Iron Bars";
		case 232: return "Door Ornate 02 - Jewels";
		case 233: return "Door Ornate 03 - Wooden Bars";
		case 234: return "Door Ornate 04 - Arched Grid";
		case 235: return "Door Ornate 05 - Block Lock";
		case 236: return "Door Ornate 06 - Corner Lock";
		case 237: return "Door Ornate 07 - Black door (Dungeon Entrance)";
		case 238: return "Door Ornate 08 - Red Triangle Lock";
		case 239: return "Door Ornate 09 - Triangle Lock";
		case 240: return "Door Ornate 10 - Ra Door Energy";
		case 241: return "Door Ornate 11 - Iron Door Damages";
		case 242: return "Door Switch";
		case 243: return "Missile 00 (Front) - Arrow";
		case 244: return "Missile 00 (Back) - Arrow";
		case 245: return "Missile 00 (Side) - Arrow";
		case 246: return "Missile 01 (Front) - Dagger";
		case 247: return "Missile 01 (Back) - Dagger";
		case 248: return "Missile 01 (Side) - Dagger";
		case 249: return "Missile 02 (Front) - Axe - Hardcleave";
		case 250: return "Missile 02 (Back) - Axe - Hardcleave";
		case 251: return "Missile 02 (Side) - Axe - Hardcleave";
		case 252: return "Missile 03 (Front) - Lightning bolt";
		case 253: return "Missile 03 (Side) - Lightning bolt";
		case 254: return "Missile 04 (Front) - Slayer";
		case 255: return "Missile 04 (Back) - Slayer";
		case 256: return "Missile 04 (Side) - Slayer";
		case 257: return "Missile 05 (Front) - Stone Club";
		case 258: return "Missile 05 (Back) - Stone Club";
		case 259: return "Missile 05 (Side) - Stone Club";
		case 260: return "Missile 06 (Front) - Club";
		case 261: return "Missile 06 (Back) - Club";
		case 262: return "Missile 06 (Side) - Club";
		case 263: return "Missile 07 (Front) - Poison Dart";
		case 264: return "Missile 07 (Back) - Poison Dart";
		case 265: return "Missile 07 (Side) - Poison Dart";
		case 266: return "Missile 08 (Front) - BoltBlade Delta DiamondEdge Falchion Fury Rapier Sabre SamuraiSword Sword Inquisitor";
		case 267: return "Missile 08 (Back) - BoltBlade Delta DiamondEdge Falchion Fury Rapier Sabre SamuraiSword Sword Inquisitor";
		case 268: return "Missile 08 (Side) - BoltBlade Delta DiamondEdge Falchion Fury Rapier Sabre SamuraiSword Sword Inquisitor";
		case 269: return "Missile 09 (Front) - Throwing Star";
		case 270: return "Missile 09 (Side) - Throwing Star";
		case 271: return "Missile 10 (Front) - Fireball";
		case 272: return "Missile 11 (Front) - Antimaterial";
		case 273: return "Missile 12 (Front) - Poison Blob";
		case 274: return "Missile 13 (Front) - Poison";
		case 275: return "Explosion 0 - Fireball";
		case 276: return "Explosion 1 - Antimaterial";
		case 277: return "Explosion 2 - Poison";
		case 278: return "Explosion 0 (Light) - Fireball";
		case 279: return "Explosion 0 (Medium) - Fireball";
		case 280: return "Explosion 0 (Strong) - Fireball";
		case 281: return "Explosion 1 (Light) - Antimaterial";
		case 282: return "Explosion 1 (Medium) - Antimaterial";
		case 283: return "Explosion 1 (Strong) - Antimaterial";
		case 284: return "Explosion 2 (Light) - Poison";
		case 285: return "Explosion 2 (Medium) - Poison";
		case 286: return "Explosion 2 (Strong) - Poison";
		case 287: return "Item on floor 00 - Chest";
		case 288: return "Item on floor 00 (Alcove) - Chest";
		case 289: return "Item on floor 01 - Scroll";
		case 290: return "Item on floor 02 - Potion (Bro Dane Ee Ku Ma Neta Ros Vi Ya) WaterFlask";
		case 291: return "Item on floor 03 - Blue Gem";
		case 292: return "Item on floor 04 - Copper Coin - Gold Coin";
		case 293: return "Item on floor 05 - Drumstick";
		case 294: return "Item on floor 06 - Waterskin (Full)";
		case 295: return "Item on floor 07 - Elven Doublet - Elven Huke";
		case 296: return "Item on floor 08 - Leather Boots";
		case 297: return "Item on floor 09 - Basinet - Bezerker Helm - Casque 'n Coif - Dexhelm - Helm Of Darc - Helmet";
		case 298: return "Item on floor 10 - Large Shield - Shield Of Darc - Shield Of Lyte - Wooden Shield";
		case 299: return "Item on floor 11 - Sling - Snake Staff - Staff - Staff Of Claws - Staff Of Manar - Yew Staff";
		case 300: return "Item on floor 12 - BoltBlade Delta DiamondEdge Falchion Fury Rapier Sabre SamuraiSword Sword Inquisitor";
		case 301: return "Item on floor 13 - Axe - Hardcleave";
		case 302: return "Item on floor 14 - Bow";
		case 303: return "Item on floor 15 - Ekkhard Cross - Gem Of Ages - Illumulet - Jewel Symal";
		case 304: return "Item on floor 16 - Arrow";
		case 305: return "Item on floor 17 - Dagger";
		case 306: return "Item on floor 18 - Key (Cross Iron Of_B Onyx Skeleton Solid Square Tourquoise)";
		case 307: return "Item on floor 19 - Flamebain - Hosen - Leg Mail - Mail Aketon - Mithral Aketon - Mithral Mail";
		case 308: return "Item on floor 20 - Plate Of Darc - Plate Of Lyte - Torso Plate";
		case 309: return "Item on floor 21 - Mace - Mace Of Order";
		case 310: return "Item on floor 22 - Leg Plate - Poleyn Of Darc - Poleyn Of Lyte - Powertowers";
		case 311: return "Item on floor 23 - Barbarian Hide - Cape - Cloak Of Night - Leather Jerkin - Leather Pants";
		case 312: return "Item on floor 24 - Fine Robe (Body Legs) - Ghi - Ghi Trousers - Robe (Body Legs) - Silk Shirt - Tabard";
		case 313: return "Item on floor 25 - Bread";
		case 314: return "Item on floor 26 - Cheese";
		case 315: return "Item on floor 27 - Apple";
		case 316: return "Item on floor 28 - Corn";
		case 317: return "Item on floor 29 - Suede Boots";
		case 318: return "Item on floor 30 - Sceptre of Lyf";
		case 319: return "Item on floor 31 - Teowand - Wand";
		case 320: return "Item on floor 32 - Dragon Spit";
		case 321: return "Item on floor 33 - Morningstar";
		case 322: return "Item on floor 34 - Compass";
		case 323: return "Item on floor 35 - Torch";
		case 324: return "Item on floor 36 - Waterskin (Empty)";
		case 325: return "Item on floor 37 - Flamitt";
		case 326: return "Item on floor 38 - Eye Of Time - Stormring";
		case 327: return "Item on floor 39 - The Firestaff";
		case 328: return "Item on floor 40 - Ashes";
		case 329: return "Item on floor 41 - Bones - Champion Bones";
		case 330: return "Item on floor 42 - Vorpal Blade";
		case 331: return "Item on floor 43 - Club";
		case 332: return "Item on floor 44 - Stone Club";
		case 333: return "Item on floor 45 - Crossbow - Speedbow";
		case 334: return "Item on floor 46 - Slayer";
		case 335: return "Item on floor 47 - Rock";
		case 336: return "Item on floor 48 - Poison Dart";
		case 337: return "Item on floor 49 - Throwing Star";
		case 338: return "Item on floor 50 - Stick";
		case 339: return "Item on floor 51 - The Conduit";
		case 340: return "Item on floor 52 - Armet - Helm Of Lyte";
		case 341: return "Item on floor 53 - Calista - Crown Of Nerra";
		case 342: return "Item on floor 54 - Buckler - Hide Shield - Small Shield";
		case 343: return "Item on floor 55 - Sandals";
		case 344: return "Item on floor 56 - Foot Plate - Greave Of Darc - Greave Of Lyte";
		case 345: return "Item on floor 57 - Elven Boots";
		case 346: return "Item on floor 58 - Moonstone";
		case 347: return "Item on floor 59 - Pendant Feral - The Hellion";
		case 348: return "Item on floor 60 - Orange Gem";
		case 349: return "Item on floor 61 - Green Gem";
		case 350: return "Item on floor 62 - Key (Emerald Gold Master Ra Ruby Sapphire Topaz Winged)";
		case 351: return "Item on floor 63 - Magical Box (Green)";
		case 352: return "Item on floor 64 - Mirror of Dawn";
		case 353: return "Item on floor 65 - Horn of Fear";
		case 354: return "Item on floor 66 - Dragon Steack";
		case 355: return "Item on floor 67 - Potion (Des Mon Sar Um Ven Zo)";
		case 356: return "Item on floor 68 - Ful Bomb - Kath Bomb - Pew Bomb - Ra Bomb";
		case 357: return "Item on floor 69 - Blue Pants - Gunna - Kirtle - Tunic";
		case 358: return "Item on floor 70 - Worm Round";
		case 359: return "Item on floor 71 - Screamer Slice";
		case 360: return "Item on floor 72 - Rope";
		case 361: return "Item on floor 73 - Rabbit's Foot";
		case 362: return "Item on floor 74 - Corbamite - Zokathra Spell";
		case 363: return "Item on floor 75 - Choker";
		case 364: return "Item on floor 76 - Boulder";
		case 365: return "Item on floor 77 - Lock Picks";
		case 366: return "Item on floor 78 - Magnifier";
		case 367: return "Item on floor 79 - Magical Box (Blue)";
		case 368: return "Item on floor 80 - Empty Flask";
		case 369: return "Item on floor 81 - Boots of Speed";
		case 370: return "Item on floor 82 - The Firestaff (Complete)";
		case 371: return "Item on floor 83 - Silver Coin";
		case 372: return "Item on floor 84 - Halter";
		case 373: return "Creature 00 (Front) - Giant Scorpion";
		case 374: return "Creature 00 (Side) - Giant Scorpion";
		case 375: return "Creature 00 (Back) - Giant Scorpion";
		case 376: return "Creature 00 (Attack) - Giant Scorpion";
		case 377: return "Creature 01 (Front) - Swamp Slime";
		case 378: return "Creature 01 (Attack) - Swamp Slime";
		case 379: return "Creature 02 (Front) - Giggler";
		case 380: return "Creature 02 (Side) - Giggler";
		case 381: return "Creature 02 (Back) - Giggler";
		case 382: return "Creature 02 (Attack) - Giggler (empty image)";
		case 383: return "Creature 03 (Front) - Wizard Eye";
		case 384: return "Creature 03 (Attack) - Wizard Eye";
		case 385: return "Creature 04 (Front) - Pain Rat";
		case 386: return "Creature 04 (Side) - Pain Rat";
		case 387: return "Creature 04 (Back) - Pain Rat";
		case 388: return "Creature 04 (Attack) - Pain Rat";
		case 389: return "Creature 05 (Front) - Ruster";
		case 390: return "Creature 05 (Side) - Ruster";
		case 391: return "Creature 05 (Back) - Ruster";
		case 392: return "Creature 06 (Front) - Screamer";
		case 393: return "Creature 06 (Attack) - Screamer";
		case 394: return "Creature 07 (Front) - Rockpile";
		case 395: return "Creature 07 (Attack) - Rockpile";
		case 396: return "Creature 08 (Front) - Ghost";
		case 397: return "Creature 08 (Attack) - Ghost";
		case 398: return "Creature 09 (Front) - Stone Golem";
		case 399: return "Creature 09 (Side) - Stone Golem";
		case 400: return "Creature 09 (Back) - Stone Golem";
		case 401: return "Creature 09 (Attack) - Stone Golem";
		case 402: return "Creature 10 (Front) - Mummy";
		case 403: return "Creature 10 (Side) - Mummy";
		case 404: return "Creature 10 (Back) - Mummy";
		case 405: return "Creature 10 (Attack) - Mummy";
		case 406: return "Creature 11 (Front) - Black Flame";
		case 407: return "Creature 11 (Attack) - Black Flame";
		case 408: return "Creature 12 (Front) - Skeleton";
		case 409: return "Creature 12 (Side) - Skeleton";
		case 410: return "Creature 12 (Back) - Skeleton";
		case 411: return "Creature 12 (Attack) - Skeleton";
		case 412: return "Creature 13 (Front) - Couatl";
		case 413: return "Creature 13 (Side) - Couatl";
		case 414: return "Creature 13 (Back) - Couatl";
		case 415: return "Creature 13 (Attack) - Couatl";
		case 416: return "Creature 14 (Front) - Vexirk";
		case 417: return "Creature 14 (Side) - Vexirk";
		case 418: return "Creature 14 (Back) - Vexirk";
		case 419: return "Creature 14 (Attack) - Vexirk";
		case 420: return "Creature 15 (Front) - Magenta Worm";
		case 421: return "Creature 15 (Side) - Magenta Worm";
		case 422: return "Creature 15 (Back) - Magenta Worm";
		case 423: return "Creature 15 (Attack) - Magenta Worm";
		case 424: return "Creature 16 (Front) - Trolin";
		case 425: return "Creature 16 (Side) - Trolin";
		case 426: return "Creature 16 (Back) - Trolin";
		case 427: return "Creature 16 (Attack) - Trolin";
		case 428: return "Creature 17 (Front) - Giant Wasp";
		case 429: return "Creature 17 (Side) - Giant Wasp";
		case 430: return "Creature 17 (Back) - Giant Wasp";
		case 431: return "Creature 17 (Attack) - Giant Wasp";
		case 432: return "Creature 18 (Front) - Animated Armour";
		case 433: return "Creature 18 (Side) - Animated Armour";
		case 434: return "Creature 18 (Back) - Animated Armour";
		case 435: return "Creature 18 (Attack) - Animated Armour";
		case 436: return "Creature 19 (Front 1) - Materializer";
		case 437: return "Creature 19 (Front 2) - Materializer";
		case 438: return "Creature 19 (Front 3) - Materializer";
		case 439: return "Creature 19 (Attack) - Materializer";
		case 440: return "Creature 20 (Front) - Water Elemental";
		case 441: return "Creature 20 (Attack) - Water Elemental";
		case 442: return "Creature 21 (Front) - Oitu";
		case 443: return "Creature 21 (Side) - Oitu";
		case 444: return "Creature 21 (Back) - Oitu";
		case 445: return "Creature 21 (Attack) - Oitu";
		case 446: return "Creature 22 (Front) - Demon";
		case 447: return "Creature 22 (Side) - Demon";
		case 448: return "Creature 22 (Back) - Demon";
		case 449: return "Creature 22 (Attack) - Demon";
		case 450: return "Creature 23 (Front) - Lord Chaos";
		case 451: return "Creature 23 (Side) - Lord Chaos";
		case 452: return "Creature 23 (Back) - Lord Chaos";
		case 453: return "Creature 23 (Attack) - Lord Chaos";
		case 454: return "Creature 24 (Front) - Red Dragon";
		case 455: return "Creature 24 (Side) - Red Dragon";
		case 456: return "Creature 24 (Back) - Red Dragon";
		case 457: return "Creature 24 (Attack) - Red Dragon";
		case 458: return "Creature 25 (Front) - Lord Order";
		case 459: return "Creature 26 (Front) - Grey Lord";
		case 460: return "Dungeon Graphics - Floor";
		case 461: return "Dungeon Graphics - Ceiling";
		case 462: return "Dungeon Graphics - Wall (Right Side 0)";
		case 463: return "Dungeon Graphics - Wall (Left Side 0)";
		case 464: return "Dungeon Graphics - Wall (Front and Sides 1)";
		case 465: return "Dungeon Graphics - Wall (Front and Sides 2)";
		case 466: return "Dungeon Graphics - Wall (Front and Sides 3)";
		case 467: return "Dungeon Graphics - Wall (Far Left Side 3)";
		case 468: return "Dungeon Graphics - Wall (Far Right Side 3)";
		case 469: return "Cursors and team";
		case 470: return "Items 1";
		case 471: return "Items 2";
		case 472: return "Items 3";
		case 473: return "Items 4";
		case 474: return "Items 5";
		case 475: return "Items 6";
		case 476: return "Items 7";
		case 477: return "Interface Parts 1";
		case 478: return "Interface Parts 2";
		case 479: return "Interface Parts 3";
		case 480: return "Portaits - 3x85+1 tiles";
		case 481: return "Alphabet 1 and Attack names";
		case 482: return "Alphabet 2";
		case 483: return "Text - Dungeon Texts (Walls";
		case 484: return "Wall Ornate 00 (Front) - Wall Inscription Frame";
		case 485: return "Introduction - Entrance - Doors";
		case 486: return "Introduction - Entrance - Border";
		case 487: return "Introduction - Entrance - Corridor";
		case 488: return "Dungeon Graphics - Floor Pit (Left Side 3)";
		case 489: return "Dungeon Graphics - Floor Pit (Front 3)";
		case 490: return "Dungeon Graphics - Floor Pit (Left Side 2)";
		case 491: return "Dungeon Graphics - Floor Pit (Front 2)";
		case 492: return "Dungeon Graphics - Floor Pit (Left Side 1)";
		case 493: return "Dungeon Graphics - Floor Pit (Front 1)";
		case 494: return "Dungeon Graphics - Floor Pit (Left Side 0)";
		case 495: return "Dungeon Graphics - Floor Pit (Front 0)";
		case 496: return "Dungeon Graphics - Invisible Floor Pit (Left Side 2)";
		case 497: return "Dungeon Graphics - Invisible Floor Pit (Front 2)";
		case 498: return "Dungeon Graphics - Invisible Floor Pit (Left Side 1)";
		case 499: return "Dungeon Graphics - Invisible Floor Pit (Front 1)";
		case 500: return "Dungeon Graphics - Invisible Floor Pit (Left Side 0)";
		case 501: return "Dungeon Graphics - Invisible Floor Pit (Front 0)";
		case 502: return "Dungeon Graphics - Ceiling Pit (Left Side 2)";
		case 503: return "Dungeon Graphics - Ceiling Pit (Front 2)";
		case 504: return "Dungeon Graphics - Ceiling Pit (Left Side 1)";
		case 505: return "Dungeon Graphics - Ceiling Pit (Front 1)";
		case 506: return "Dungeon Graphics - Ceiling Pit (Left Side 0)";
		case 507: return "Dungeon Graphics - Ceiling Pit (Front 0)";
		case 508: return "Dungeon Graphics - Wall Mask (Right Front 3)";
		case 509: return "Dungeon Graphics - Wall Mask (Right Front 2)";
		case 510: return "Dungeon Graphics - Wall Mask (Right Front 1)";
		case 511: return "Dungeon Graphics - Wall Mask (Right Front 0)";
		case 512: return "Dungeon Graphics - Teleporter";
		case 513: return "Dungeon Graphics - Fluxcage";
		case 514: return "Dungeon Graphics - Hole In Wall While Using 'See Through Walls' Spell";
		case 515: return "Music program 'Start swoosh'";
		case 516: return "Unknown data probably another music program";
		case 517: return "Music program 'Hall of champions'";
		case 518: return "Music program 'Chambers of the Guardian'";
		case 519: return "Music program 'Room of the Gem & After Teleports'";
		case 520: return "Music program 'Scorpions!'";
		case 521: return "Music program 'Gigglers'";
		case 522: return "Music program 'The Matrix & Forever Room'";
		case 523: return "Music program 'Choose your fate'";
		case 524: return "Music program 'Entrance & Power Gem & End Screen'";
		case 525: return "Music program 'Screamers'";
		case 526: return "Music program 'Riddle Room & Not Rock'";
		case 527: return "Music program 'Tomb of the Firestaff'";
		case 528: return "Music program 'I hate cowards'";
		case 529: return "Music program 'Prepare to meet your Doom & Lord Chaos'";
		case 530: return "Music program 'The Lone Knight'";
		case 531: return "Music program 'Introduction'";
		case 532: return "Music program 'End credits'";
		case 533: return "Music program 'Clockwise!'";
		case 534: return "Unknown data";
		case 535: return "One byte 0x1A";
		case 536: return "One byte 0x1A";
		case 537: return "One byte 0x1A";
		case 538: return "One byte 0x1A";
		case 539: return "One byte 0x1A";
		case 540: return "Unknown data";
		case 541: return "Unknown data";
		case 542: return "Unknown data";
		case 543: return "Unknown data";
		case 544: return "Unknown data";
		case 545: return "Unknown data";
		case 546: return "Unknown data";
		case 547: return "One byte 0x1A";
		case 548: return "Unknown data";
		case 549: return "Unknown data";
		case 550: return "Unknown data";
		case 551: return "Unknown data";
		case 552: return "Unknown data";
		case 553: return "Unknown data";
		case 554: return "Unknown data";
		case 555: return "Unknown data";
		case 556: return "Unknown data";
		case 557: return "Unknown data";
		case 558: return "Unknown data";
		case 559: return "Unknown data";
		case 560: return "Unknown data";
		case 561: return "Unknown data";
		case 562: return "Unknown data";
		case 563: return "Unknown data";
		case 564: return "Unknown data";
		case 565: return "Unknown data";
		case 566: return "Unknown data";
		case 567: return "Unknown data";
		case 568: return "Unknown data";
		case 569: return "Unknown data";
		case 570: return "Unknown data";
		case 571: return "Unknown data";
		case 572: return "Unknown data";
		case 573: return "Unknown data";
		case 574: return "Unknown data";
		case 575: return "Unknown data";
		case 576: return "Unknown data";
		case 577: return "Unknown data";
		case 578: return "Unknown data";
		case 579: return "Unknown data";
		case 580: return "Unknown data";
		case 581: return "Unknown data";
		case 582: return "One byte 0x1A";
		case 583: return "Sound xx - Sample 1";
		case 584: return "Sound xx - Sample 2";
		case 585: return "Sound xx - Sample 3";
		case 586: return "Sound xx - Sample 4";
		case 587: return "Sound xx - Sample 5";
		case 588: return "Sound xx - Sample 6";
		case 589: return "Sound xx - Sample 7";
		case 590: return "Sound xx - Sample 8";
		case 591: return "Sound xx - Sample 9";
		case 592: return "Sound xx - Sample 10";
		case 593: return "Sound xx - Sample 11";
		case 594: return "Sound xx - Sample 12";
		case 595: return "Sound xx - Sample 13";
		case 596: return "Sound xx - Sample 14";
		case 597: return "Sound xx - Sample 15";
		case 598: return "Empty - One byte 0x20";
		case 599: return "Sound xx - to be identified";
		case 600: return "Sound xx - to be identified";
		case 601: return "Sound xx - to be identified";
		case 602: return "Empty - One byte 0x20";
		case 603: return "Empty - One byte 0x20";
		case 604: return "Empty - One byte 0x20";
		case 605: return "Empty - One byte 0x20";
		case 606: return "Empty - One byte 0x20";
		case 607: return "Empty - One byte 0x20";
		case 608: return "Empty - One byte 0x20";
		case 609: return "Empty - One byte 0x20";
		case 610: return "Empty - One byte 0x20";
		case 611: return "Empty - One byte 0x20";
		case 612: return "Empty - One byte 0x20";
		case 613: return "Empty - One byte 0x20";
		case 614: return "Empty - One byte 0x20";
		case 615: return "Sound xx - Move (Red Dragon)";
		case 616: return "Sound xx - Falling item";
		case 617: return "Sound xx - Move (Animated Armour)";
		case 618: return "Empty - One byte 0x20";
		case 619: return "Sound xx - Attack (Couatl)";
		case 620: return "Sound xx - Door";
		case 621: return "Empty - One byte 0x20";
		case 622: return "Sound xx - Attack (Pain Rat - Red Dragon)";
		case 623: return "Sound xx - Attack (Trolin - Stone Golem) - Touching Wall";
		case 624: return "Sound xx - Exploding Fireball";
		case 625: return "Sound xx - Falling and Dying";
		case 626: return "Sound xx - Move (Giant Wasp - Couatl)";
		case 627: return "Sound xx - Switch";
		case 628: return "Sound xx - Attack (Mummy - Ghost)";
		case 629: return "Sound xx - Attack (Giggler)";
		case 630: return "Sound xx - Swallowing";
		case 631: return "Sound xx - Champion Wounded 1";
		case 632: return "Empty - One byte 0x20";
		case 633: return "Empty - One byte 0x20";
		case 634: return "Empty - One byte 0x20";
		case 635: return "Sound xx - Running Into A Wall";
		case 636: return "Empty - One byte 0x20";
		case 637: return "Sound xx - Exploding Spell";
		case 638: return "Sound xx - Attack (Screamer - Oitu)";
		case 639: return "Sound xx - Attack (Rockpile)";
		case 640: return "Sound xx - Attack (Giant Scorpion)";
		case 641: return "Sound xx - Move (Screamer - Rockpile - Magenta Worm - Pain Rat - Ruster - Giant Scorpion - Oitu)";
		case 642: return "Sound xx - Move (Skeleton)";
		case 643: return "Sound xx - Move (Swamp Slime - Water Elemental)";
		case 644: return "Sound xx - Attack (Skeleton - Animated Armour - Party Slash)";
		case 645: return "Empty - One byte 0x20";
		case 646: return "Sound xx - War Cry";
		case 647: return "Sound xx - Attack (Water Elemental)";
		case 648: return "Sound xx - Attack (Magenta Worm)";
		case 649: return "Unknown data";
		case 650: return "Unknown data";
		case 651: return "Unknown data";
		case 652: return "Unknown data";
		case 653: return "Unknown data";
		case 654: return "Unknown data";
		case 655: return "Unknown data";
		case 656: return "Dragon wall - Dialog boxes background";
		case 657: return "Dragon wall - Text zone clicked";
		case 658: return "Dragon wall - Text zone";
		case 659: return "'Victor'";
		case 660: return "Introduction - Title 'Dungeon'";
		case 661: return "Introduction - Title 'Master' and copyright";
		case 662: return "Introduction - Circles 1";
		case 663: return "Introduction - Lightning and alphabet";
		case 664: return "Introduction - Circles 2";
		case 665: return "Introduction - Grey Lord and Dragon";
		case 666: return "Automap icons";
		case 667: return "Map - Level 00";
		case 668: return "Map - Level 01";
		case 669: return "Map - Level 02";
		case 670: return "Map - Level 03";
		case 671: return "Map - Level 04";
		case 672: return "Map - Level 05";
		case 673: return "Map - Level 06";
		case 674: return "Map - Level 07";
		case 675: return "Map - Level 08";
		case 676: return "Map - Level 09";
		case 677: return "Map - Level 10";
		case 678: return "Map - Level 11";
		case 679: return "Map - Level 12";
		case 680: return "Map - Level 13";
		case 681: return "End - Walls";
		case 682: return "End - Clouds";
		case 683: return "End - Grey Lord";
		case 684: return "End - Walls";
		case 685: return "End - Clouds";
		case 686: return "Introduction - Text 2 (Japanese text unused in US version)";
		case 687: return "End - Credits-Letters-Victor-FTL-Portait";
		case 688: return "End - Credits text";
		case 689: return "End - 'Game over' message displayed when party dies";
		case 690: return "End - Skulls displayed when party dies";
		case 691: return "End - 'Game Over' message";
		case 692: return "End - Skulls";
		case 693: return "Introduction - Dungeon entrance (border)";
		case 694: return "Introduction - Dungeon entrance (corridor)";
	}
	
	return "undefined";
}
